/*
 * Copyright 2023 Stanislav Mikhailov (xavetar)
 *
 * Licensed under the Creative Commons Zero v1.0 Universal (CC0) License.
 * You may obtain a copy of the License at
 *
 *     http://creativecommons.org/publicdomain/zero/1.0/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the CC0 license is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// It is strictly forbidden to use the from_code method, respected Microsoft decided to define
// duplicate codes, but by defining different constant names, therefore, when using these codes,
// it is mandatory to use through from_name, and not from_code. Otherwise, it may cause undefined
// behavior or an unknown exception. Because one code corresponds to several constants.

use super::{RawError};

#[derive(Clone, Debug, Copy, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum SHELL_NAP {
    COPYENGINE_S_YES,
    COPYENGINE_S_NOT_HANDLED,
    COPYENGINE_S_USER_RETRY,
    COPYENGINE_S_USER_IGNORED,
    COPYENGINE_S_MERGE,
    COPYENGINE_S_DONT_PROCESS_CHILDREN,
    COPYENGINE_S_ALREADY_DONE,
    COPYENGINE_S_PENDING,
    COPYENGINE_S_KEEP_BOTH,
    NAP_S_CERT_ALREADY_PRESENT,
    COPYENGINE_S_CLOSE_PROGRAM,
    COPYENGINE_S_COLLISIONRESOLVED,
    COPYENGINE_S_PROGRESS_PAUSE,
    S_STORE_LAUNCHED_FOR_REMEDIATION,
    S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG,
    COPYENGINE_E_USER_CANCELLED,
    NAP_E_INVALID_PACKET,
    COPYENGINE_E_CANCELLED,
    NAP_E_MISSING_SOH,
    COPYENGINE_E_REQUIRES_ELEVATION,
    NAP_E_CONFLICTING_ID,
    COPYENGINE_E_SAME_FILE,
    NAP_E_NO_CACHED_SOH,
    COPYENGINE_E_DIFF_DIR,
    NAP_E_STILL_BOUND,
    COPYENGINE_E_MANY_SRC_1_DEST,
    NAP_E_NOT_REGISTERED,
    NAP_E_NOT_INITIALIZED,
    NAP_E_MISMATCHED_ID,
    NAP_E_NOT_PENDING,
    COPYENGINE_E_DEST_SUBTREE,
    NAP_E_ID_NOT_FOUND,
    COPYENGINE_E_DEST_SAME_TREE,
    NAP_E_MAXSIZE_TOO_SMALL,
    COPYENGINE_E_FLD_IS_FILE_DEST,
    NAP_E_SERVICE_NOT_RUNNING,
    COPYENGINE_E_FILE_IS_FLD_DEST,
    COPYENGINE_E_FILE_TOO_LARGE,
    NAP_E_ENTITY_DISABLED,
    COPYENGINE_E_REMOVABLE_FULL,
    NAP_E_NETSH_GROUPPOLICY_ERROR,
    COPYENGINE_E_DEST_IS_RO_CD,
    NAP_E_TOO_MANY_CALLS,
    COPYENGINE_E_DEST_IS_RW_CD,
    NAP_E_SHV_CONFIG_EXISTED,
    COPYENGINE_E_DEST_IS_R_CD,
    NAP_E_SHV_CONFIG_NOT_FOUND,
    COPYENGINE_E_DEST_IS_RO_DVD,
    NAP_E_SHV_TIMEOUT,
    COPYENGINE_E_DEST_IS_RW_DVD,
    COPYENGINE_E_DEST_IS_R_DVD,
    COPYENGINE_E_SRC_IS_RO_CD,
    COPYENGINE_E_SRC_IS_RW_CD,
    COPYENGINE_E_SRC_IS_R_CD,
    COPYENGINE_E_SRC_IS_RO_DVD,
    COPYENGINE_E_SRC_IS_RW_DVD,
    COPYENGINE_E_SRC_IS_R_DVD,
    COPYENGINE_E_INVALID_FILES_SRC,
    COPYENGINE_E_INVALID_FILES_DEST,
    COPYENGINE_E_PATH_TOO_DEEP_SRC,
    COPYENGINE_E_PATH_TOO_DEEP_DEST,
    COPYENGINE_E_ROOT_DIR_SRC,
    COPYENGINE_E_ROOT_DIR_DEST,
    COPYENGINE_E_ACCESS_DENIED_SRC,
    COPYENGINE_E_ACCESS_DENIED_DEST,
    COPYENGINE_E_PATH_NOT_FOUND_SRC,
    COPYENGINE_E_PATH_NOT_FOUND_DEST,
    COPYENGINE_E_NET_DISCONNECT_SRC,
    COPYENGINE_E_NET_DISCONNECT_DEST,
    COPYENGINE_E_SHARING_VIOLATION_SRC,
    COPYENGINE_E_SHARING_VIOLATION_DEST,
    COPYENGINE_E_ALREADY_EXISTS_NORMAL,
    COPYENGINE_E_ALREADY_EXISTS_READONLY,
    COPYENGINE_E_ALREADY_EXISTS_SYSTEM,
    COPYENGINE_E_ALREADY_EXISTS_FOLDER,
    COPYENGINE_E_STREAM_LOSS,
    COPYENGINE_E_EA_LOSS,
    COPYENGINE_E_PROPERTY_LOSS,
    COPYENGINE_E_PROPERTIES_LOSS,
    COPYENGINE_E_ENCRYPTION_LOSS,
    COPYENGINE_E_DISK_FULL,
    COPYENGINE_E_DISK_FULL_CLEAN,
    COPYENGINE_E_EA_NOT_SUPPORTED,
    COPYENGINE_E_CANT_REACH_SOURCE,
    COPYENGINE_E_RECYCLE_UNKNOWN_ERROR,
    COPYENGINE_E_RECYCLE_FORCE_NUKE,
    COPYENGINE_E_RECYCLE_SIZE_TOO_BIG,
    COPYENGINE_E_RECYCLE_PATH_TOO_LONG,
    COPYENGINE_E_RECYCLE_BIN_NOT_FOUND,
    COPYENGINE_E_NEWFILE_NAME_TOO_LONG,
    COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG,
    COPYENGINE_E_DIR_NOT_EMPTY,
    COPYENGINE_E_FAT_MAX_IN_ROOT,
    COPYENGINE_E_ACCESSDENIED_READONLY,
    COPYENGINE_E_REDIRECTED_TO_WEBPAGE,
    COPYENGINE_E_SERVER_BAD_FILE_TYPE,
    COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE,
    COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN,
    COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER,
    COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR,
    COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED,
    COPYENGINE_E_REQUIRES_EDP_CONSENT,
    COPYENGINE_E_BLOCKED_BY_EDP_POLICY,
    COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
    COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
    COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
    COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
    NETCACHE_E_NEGATIVE_CACHE,
    EXECUTE_E_LAUNCH_APPLICATION,
    SHELL_E_WRONG_BITDEPTH,
    LINK_E_DELETE,
    STORE_E_NEWER_VERSION_AVAILABLE,
    E_FILE_PLACEHOLDER_NOT_INITIALIZED,
    E_FILE_PLACEHOLDER_VERSION_MISMATCH,
    E_FILE_PLACEHOLDER_SERVER_TIMED_OUT,
    E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND,
    CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED,
    LIBRARY_E_NO_SAVE_LOCATION,
    LIBRARY_E_NO_ACCESSIBLE_LOCATION,
    E_USERTILE_UNSUPPORTEDFILETYPE,
    E_USERTILE_CHANGEDISABLED,
    E_USERTILE_LARGEORDYNAMIC,
    E_USERTILE_VIDEOFRAMESIZE,
    E_USERTILE_FILESIZE,
    FA_E_MAX_PERSISTED_ITEMS_REACHED,
    FA_E_HOMEGROUP_NOT_AVAILABLE,
    IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT,
    IMM_ACC_DOCKING_E_DOCKOCCUPIED,
    IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE,
    SHC_E_SHELL_COMPONENT_STARTUP_FAILURE,
    E_TILE_NOTIFICATIONS_PLATFORM_FAILURE,
    E_MONITOR_RESOLUTION_TOO_LOW,
    E_ELEVATED_ACTIVATION_NOT_SUPPORTED,
    E_UAC_DISABLED,
    E_FULL_ADMIN_NOT_SUPPORTED,
    E_APPLICATION_NOT_REGISTERED,
    E_MULTIPLE_EXTENSIONS_FOR_APPLICATION,
    E_MULTIPLE_PACKAGES_FOR_FAMILY,
    E_APPLICATION_MANAGER_NOT_RUNNING,
    E_APPLICATION_ACTIVATION_TIMED_OUT,
    E_APPLICATION_ACTIVATION_EXEC_FAILURE,
    E_APPLICATION_TEMPORARY_LICENSE_ERROR,
    E_APPLICATION_TRIAL_LICENSE_EXPIRED,
    E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED,
    E_SKYDRIVE_ROOT_TARGET_OVERLAP,
    E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX,
    E_SKYDRIVE_FILE_NOT_UPLOADED,
    E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL,
    E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED,
    E_SHELL_EXTENSION_BLOCKED,
    E_IMAGEFEED_CHANGEDISABLED,
}

impl SHELL_NAP {
    pub fn code(&self) -> u32 {
        return match self {
            SHELL_NAP::COPYENGINE_S_YES => 0x00270001 as u32,
            SHELL_NAP::COPYENGINE_S_NOT_HANDLED => 0x00270003 as u32,
            SHELL_NAP::COPYENGINE_S_USER_RETRY => 0x00270004 as u32,
            SHELL_NAP::COPYENGINE_S_USER_IGNORED => 0x00270005 as u32,
            SHELL_NAP::COPYENGINE_S_MERGE => 0x00270006 as u32,
            SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN => 0x00270008 as u32,
            SHELL_NAP::COPYENGINE_S_ALREADY_DONE => 0x0027000A as u32,
            SHELL_NAP::COPYENGINE_S_PENDING => 0x0027000B as u32,
            SHELL_NAP::COPYENGINE_S_KEEP_BOTH => 0x0027000C as u32,
            SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT => 0x0027000D as u32,
            SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM => 0x0027000D as u32,
            SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED => 0x0027000E as u32,
            SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE => 0x0027000F as u32,
            SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION => 0x00270258 as u32,
            SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG => 0x00270259 as u32,
            SHELL_NAP::COPYENGINE_E_USER_CANCELLED => 0x80270000 as u32,
            SHELL_NAP::NAP_E_INVALID_PACKET => 0x80270001 as u32,
            SHELL_NAP::COPYENGINE_E_CANCELLED => 0x80270001 as u32,
            SHELL_NAP::NAP_E_MISSING_SOH => 0x80270002 as u32,
            SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION => 0x80270002 as u32,
            SHELL_NAP::NAP_E_CONFLICTING_ID => 0x80270003 as u32,
            SHELL_NAP::COPYENGINE_E_SAME_FILE => 0x80270003 as u32,
            SHELL_NAP::NAP_E_NO_CACHED_SOH => 0x80270004 as u32,
            SHELL_NAP::COPYENGINE_E_DIFF_DIR => 0x80270004 as u32,
            SHELL_NAP::NAP_E_STILL_BOUND => 0x80270005 as u32,
            SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST => 0x80270005 as u32,
            SHELL_NAP::NAP_E_NOT_REGISTERED => 0x80270006 as u32,
            SHELL_NAP::NAP_E_NOT_INITIALIZED => 0x80270007 as u32,
            SHELL_NAP::NAP_E_MISMATCHED_ID => 0x80270008 as u32,
            SHELL_NAP::NAP_E_NOT_PENDING => 0x80270009 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_SUBTREE => 0x80270009 as u32,
            SHELL_NAP::NAP_E_ID_NOT_FOUND => 0x8027000A as u32,
            SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE => 0x8027000A as u32,
            SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL => 0x8027000B as u32,
            SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST => 0x8027000B as u32,
            SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING => 0x8027000C as u32,
            SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST => 0x8027000C as u32,
            SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE => 0x8027000D as u32,
            SHELL_NAP::NAP_E_ENTITY_DISABLED => 0x8027000E as u32,
            SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL => 0x8027000E as u32,
            SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR => 0x8027000F as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD => 0x8027000F as u32,
            SHELL_NAP::NAP_E_TOO_MANY_CALLS => 0x80270010 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD => 0x80270010 as u32,
            SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED => 0x80270011 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD => 0x80270011 as u32,
            SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND => 0x80270012 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD => 0x80270012 as u32,
            SHELL_NAP::NAP_E_SHV_TIMEOUT => 0x80270013 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD => 0x80270013 as u32,
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD => 0x80270014 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD => 0x80270015 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD => 0x80270016 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD => 0x80270017 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD => 0x80270018 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD => 0x80270019 as u32,
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD => 0x8027001A as u32,
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC => 0x8027001B as u32,
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST => 0x8027001C as u32,
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC => 0x8027001D as u32,
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST => 0x8027001E as u32,
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC => 0x8027001F as u32,
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST => 0x80270020 as u32,
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC => 0x80270021 as u32,
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST => 0x80270022 as u32,
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC => 0x80270023 as u32,
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST => 0x80270024 as u32,
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC => 0x80270025 as u32,
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST => 0x80270026 as u32,
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC => 0x80270027 as u32,
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST => 0x80270028 as u32,
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL => 0x80270029 as u32,
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY => 0x8027002A as u32,
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM => 0x8027002B as u32,
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER => 0x8027002C as u32,
            SHELL_NAP::COPYENGINE_E_STREAM_LOSS => 0x8027002D as u32,
            SHELL_NAP::COPYENGINE_E_EA_LOSS => 0x8027002E as u32,
            SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS => 0x8027002F as u32,
            SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS => 0x80270030 as u32,
            SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS => 0x80270031 as u32,
            SHELL_NAP::COPYENGINE_E_DISK_FULL => 0x80270032 as u32,
            SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN => 0x80270033 as u32,
            SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED => 0x80270034 as u32,
            SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE => 0x80270035 as u32,
            SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR => 0x80270035 as u32,
            SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE => 0x80270036 as u32,
            SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG => 0x80270037 as u32,
            SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG => 0x80270038 as u32,
            SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND => 0x8027003A as u32,
            SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG => 0x8027003B as u32,
            SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG => 0x8027003C as u32,
            SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY => 0x8027003D as u32,
            SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT => 0x8027003E as u32,
            SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY => 0x8027003F as u32,
            SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE => 0x80270040 as u32,
            SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE => 0x80270041 as u32,
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE => 0x80270042 as u32,
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN => 0x80270043 as u32,
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER => 0x80270044 as u32,
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR => 0x80270045 as u32,
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED => 0x80270046 as u32,
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT => 0x80270047 as u32,
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY => 0x80270048 as u32,
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => 0x80270049 as u32,
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => 0x8027004A as u32,
            SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => 0x8027004B as u32,
            SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => 0x8027004C as u32,
            SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE => 0x80270100 as u32,
            SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION => 0x80270101 as u32,
            SHELL_NAP::SHELL_E_WRONG_BITDEPTH => 0x80270102 as u32,
            SHELL_NAP::LINK_E_DELETE => 0x80270103 as u32,
            SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE => 0x80270104 as u32,
            SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED => 0x80270110 as u32,
            SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH => 0x80270111 as u32,
            SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT => 0x80270112 as u32,
            SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND => 0x80270113 as u32,
            SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED => 0x80270120 as u32,
            SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION => 0x80270200 as u32,
            SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION => 0x80270201 as u32,
            SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE => 0x80270210 as u32,
            SHELL_NAP::E_USERTILE_CHANGEDISABLED => 0x80270211 as u32,
            SHELL_NAP::E_USERTILE_LARGEORDYNAMIC => 0x80270212 as u32,
            SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE => 0x80270213 as u32,
            SHELL_NAP::E_USERTILE_FILESIZE => 0x80270214 as u32,
            SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED => 0x80270220 as u32,
            SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE => 0x80270222 as u32,
            SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT => 0x80270230 as u32,
            SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED => 0x80270231 as u32,
            SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE => 0x80270233 as u32,
            SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE => 0x80270234 as u32,
            SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE => 0x80270249 as u32,
            SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW => 0x80270250 as u32,
            SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED => 0x80270251 as u32,
            SHELL_NAP::E_UAC_DISABLED => 0x80270252 as u32,
            SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED => 0x80270253 as u32,
            SHELL_NAP::E_APPLICATION_NOT_REGISTERED => 0x80270254 as u32,
            SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION => 0x80270255 as u32,
            SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY => 0x80270256 as u32,
            SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING => 0x80270257 as u32,
            SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT => 0x8027025A as u32,
            SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE => 0x8027025B as u32,
            SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR => 0x8027025C as u32,
            SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED => 0x8027025D as u32,
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED => 0x80270260 as u32,
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP => 0x80270261 as u32,
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX => 0x80270262 as u32,
            SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED => 0x80270263 as u32,
            SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL => 0x80270264 as u32,
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED => 0x80270265 as u32,
            SHELL_NAP::E_SHELL_EXTENSION_BLOCKED => 0x80270301 as u32,
            SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED => 0x80270310 as u32,
        }
    }

    pub fn error(&self) -> RawError {
        return match self {
            SHELL_NAP::COPYENGINE_S_YES => RawError::Kind(SHELL_NAP::COPYENGINE_S_YES),
            SHELL_NAP::COPYENGINE_S_NOT_HANDLED => RawError::Kind(SHELL_NAP::COPYENGINE_S_NOT_HANDLED),
            SHELL_NAP::COPYENGINE_S_USER_RETRY => RawError::Kind(SHELL_NAP::COPYENGINE_S_USER_RETRY),
            SHELL_NAP::COPYENGINE_S_USER_IGNORED => RawError::Kind(SHELL_NAP::COPYENGINE_S_USER_IGNORED),
            SHELL_NAP::COPYENGINE_S_MERGE => RawError::Kind(SHELL_NAP::COPYENGINE_S_MERGE),
            SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN => RawError::Kind(SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN),
            SHELL_NAP::COPYENGINE_S_ALREADY_DONE => RawError::Kind(SHELL_NAP::COPYENGINE_S_ALREADY_DONE),
            SHELL_NAP::COPYENGINE_S_PENDING => RawError::Kind(SHELL_NAP::COPYENGINE_S_PENDING),
            SHELL_NAP::COPYENGINE_S_KEEP_BOTH => RawError::Kind(SHELL_NAP::COPYENGINE_S_KEEP_BOTH),
            SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT => RawError::Kind(SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT),
            SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM => RawError::Kind(SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM),
            SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED => RawError::Kind(SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED),
            SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE => RawError::Kind(SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE),
            SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION => RawError::Kind(SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION),
            SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG => RawError::Kind(SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG),
            SHELL_NAP::COPYENGINE_E_USER_CANCELLED => RawError::Kind(SHELL_NAP::COPYENGINE_E_USER_CANCELLED),
            SHELL_NAP::NAP_E_INVALID_PACKET => RawError::Kind(SHELL_NAP::NAP_E_INVALID_PACKET),
            SHELL_NAP::COPYENGINE_E_CANCELLED => RawError::Kind(SHELL_NAP::COPYENGINE_E_CANCELLED),
            SHELL_NAP::NAP_E_MISSING_SOH => RawError::Kind(SHELL_NAP::NAP_E_MISSING_SOH),
            SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION => RawError::Kind(SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION),
            SHELL_NAP::NAP_E_CONFLICTING_ID => RawError::Kind(SHELL_NAP::NAP_E_CONFLICTING_ID),
            SHELL_NAP::COPYENGINE_E_SAME_FILE => RawError::Kind(SHELL_NAP::COPYENGINE_E_SAME_FILE),
            SHELL_NAP::NAP_E_NO_CACHED_SOH => RawError::Kind(SHELL_NAP::NAP_E_NO_CACHED_SOH),
            SHELL_NAP::COPYENGINE_E_DIFF_DIR => RawError::Kind(SHELL_NAP::COPYENGINE_E_DIFF_DIR),
            SHELL_NAP::NAP_E_STILL_BOUND => RawError::Kind(SHELL_NAP::NAP_E_STILL_BOUND),
            SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST),
            SHELL_NAP::NAP_E_NOT_REGISTERED => RawError::Kind(SHELL_NAP::NAP_E_NOT_REGISTERED),
            SHELL_NAP::NAP_E_NOT_INITIALIZED => RawError::Kind(SHELL_NAP::NAP_E_NOT_INITIALIZED),
            SHELL_NAP::NAP_E_MISMATCHED_ID => RawError::Kind(SHELL_NAP::NAP_E_MISMATCHED_ID),
            SHELL_NAP::NAP_E_NOT_PENDING => RawError::Kind(SHELL_NAP::NAP_E_NOT_PENDING),
            SHELL_NAP::COPYENGINE_E_DEST_SUBTREE => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_SUBTREE),
            SHELL_NAP::NAP_E_ID_NOT_FOUND => RawError::Kind(SHELL_NAP::NAP_E_ID_NOT_FOUND),
            SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE),
            SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL => RawError::Kind(SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL),
            SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST),
            SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING => RawError::Kind(SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING),
            SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST),
            SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE => RawError::Kind(SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE),
            SHELL_NAP::NAP_E_ENTITY_DISABLED => RawError::Kind(SHELL_NAP::NAP_E_ENTITY_DISABLED),
            SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL => RawError::Kind(SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL),
            SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR => RawError::Kind(SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR),
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD),
            SHELL_NAP::NAP_E_TOO_MANY_CALLS => RawError::Kind(SHELL_NAP::NAP_E_TOO_MANY_CALLS),
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD),
            SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED => RawError::Kind(SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED),
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD),
            SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND => RawError::Kind(SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND),
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD),
            SHELL_NAP::NAP_E_SHV_TIMEOUT => RawError::Kind(SHELL_NAP::NAP_E_SHV_TIMEOUT),
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD),
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD),
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD => RawError::Kind(SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD),
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC),
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST),
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC),
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST),
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC),
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST),
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC),
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST),
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC),
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST),
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC),
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST),
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC => RawError::Kind(SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC),
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST => RawError::Kind(SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST),
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL => RawError::Kind(SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL),
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY => RawError::Kind(SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY),
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM => RawError::Kind(SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM),
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER => RawError::Kind(SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER),
            SHELL_NAP::COPYENGINE_E_STREAM_LOSS => RawError::Kind(SHELL_NAP::COPYENGINE_E_STREAM_LOSS),
            SHELL_NAP::COPYENGINE_E_EA_LOSS => RawError::Kind(SHELL_NAP::COPYENGINE_E_EA_LOSS),
            SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS => RawError::Kind(SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS),
            SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS => RawError::Kind(SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS),
            SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS => RawError::Kind(SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS),
            SHELL_NAP::COPYENGINE_E_DISK_FULL => RawError::Kind(SHELL_NAP::COPYENGINE_E_DISK_FULL),
            SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN => RawError::Kind(SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN),
            SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED => RawError::Kind(SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED),
            SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE => RawError::Kind(SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE),
            SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR => RawError::Kind(SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR),
            SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE => RawError::Kind(SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE),
            SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG => RawError::Kind(SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG),
            SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG => RawError::Kind(SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG),
            SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND => RawError::Kind(SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND),
            SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG => RawError::Kind(SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG),
            SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG => RawError::Kind(SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG),
            SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY => RawError::Kind(SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY),
            SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT => RawError::Kind(SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT),
            SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY => RawError::Kind(SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY),
            SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE => RawError::Kind(SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE),
            SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE => RawError::Kind(SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE),
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE => RawError::Kind(SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE),
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN => RawError::Kind(SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN),
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER => RawError::Kind(SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER),
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR => RawError::Kind(SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR),
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED => RawError::Kind(SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED),
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT => RawError::Kind(SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT),
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY => RawError::Kind(SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY),
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => RawError::Kind(SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE),
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => RawError::Kind(SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE),
            SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => RawError::Kind(SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE),
            SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => RawError::Kind(SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE),
            SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE => RawError::Kind(SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE),
            SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION => RawError::Kind(SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION),
            SHELL_NAP::SHELL_E_WRONG_BITDEPTH => RawError::Kind(SHELL_NAP::SHELL_E_WRONG_BITDEPTH),
            SHELL_NAP::LINK_E_DELETE => RawError::Kind(SHELL_NAP::LINK_E_DELETE),
            SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE => RawError::Kind(SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE),
            SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED => RawError::Kind(SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED),
            SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH => RawError::Kind(SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH),
            SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT => RawError::Kind(SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT),
            SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND => RawError::Kind(SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND),
            SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED => RawError::Kind(SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED),
            SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION => RawError::Kind(SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION),
            SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION => RawError::Kind(SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION),
            SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE => RawError::Kind(SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE),
            SHELL_NAP::E_USERTILE_CHANGEDISABLED => RawError::Kind(SHELL_NAP::E_USERTILE_CHANGEDISABLED),
            SHELL_NAP::E_USERTILE_LARGEORDYNAMIC => RawError::Kind(SHELL_NAP::E_USERTILE_LARGEORDYNAMIC),
            SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE => RawError::Kind(SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE),
            SHELL_NAP::E_USERTILE_FILESIZE => RawError::Kind(SHELL_NAP::E_USERTILE_FILESIZE),
            SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED => RawError::Kind(SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED),
            SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE => RawError::Kind(SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE),
            SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT => RawError::Kind(SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT),
            SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED => RawError::Kind(SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED),
            SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE => RawError::Kind(SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE),
            SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE => RawError::Kind(SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE),
            SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE => RawError::Kind(SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE),
            SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW => RawError::Kind(SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW),
            SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED => RawError::Kind(SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED),
            SHELL_NAP::E_UAC_DISABLED => RawError::Kind(SHELL_NAP::E_UAC_DISABLED),
            SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED => RawError::Kind(SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED),
            SHELL_NAP::E_APPLICATION_NOT_REGISTERED => RawError::Kind(SHELL_NAP::E_APPLICATION_NOT_REGISTERED),
            SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION => RawError::Kind(SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION),
            SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY => RawError::Kind(SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY),
            SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING => RawError::Kind(SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING),
            SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT => RawError::Kind(SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT),
            SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE => RawError::Kind(SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE),
            SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR => RawError::Kind(SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR),
            SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED => RawError::Kind(SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED),
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED => RawError::Kind(SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED),
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP => RawError::Kind(SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP),
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX => RawError::Kind(SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX),
            SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED => RawError::Kind(SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED),
            SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL => RawError::Kind(SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL),
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED => RawError::Kind(SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED),
            SHELL_NAP::E_SHELL_EXTENSION_BLOCKED => RawError::Kind(SHELL_NAP::E_SHELL_EXTENSION_BLOCKED),
            SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED => RawError::Kind(SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED),
        }
    }

    pub fn description(&self) -> &'static str {
        return match self {
            SHELL_NAP::COPYENGINE_S_YES => "User responded 'Yes' to the dialog.",
            SHELL_NAP::COPYENGINE_S_NOT_HANDLED => "Description is missing",
            SHELL_NAP::COPYENGINE_S_USER_RETRY => "User responded to retry the current action.",
            SHELL_NAP::COPYENGINE_S_USER_IGNORED => "User responded 'No' to the dialog.",
            SHELL_NAP::COPYENGINE_S_MERGE => "User responded to merge folders.",
            SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN => "Child items should not be processed.",
            SHELL_NAP::COPYENGINE_S_ALREADY_DONE => "Description is missing",
            SHELL_NAP::COPYENGINE_S_PENDING => "Error has been queued and will display later.",
            SHELL_NAP::COPYENGINE_S_KEEP_BOTH => "Description is missing",
            SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT => "A certificate is already present in the cert store.",
            SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM => "Close the program using the current file",
            SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED => "Returned by a transfer source when a collision occurs during a file operation but the source resolved the collision on the users behalf",
            SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE => "Description is missing",
            SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION => "The Store was launched instead of the specified app because the app's package was in an invalid state.",
            SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG => "This app failed to launch, but the error was handled with a dialog.",
            SHELL_NAP::COPYENGINE_E_USER_CANCELLED => "User wants to canceled entire job",
            SHELL_NAP::NAP_E_INVALID_PACKET => "The NAP SoH packet is invalid.",
            SHELL_NAP::COPYENGINE_E_CANCELLED => "Engine wants to canceled entire job, don&#x27;t set the CANCELLED bit",
            SHELL_NAP::NAP_E_MISSING_SOH => "An SoH was missing from the NAP packet.",
            SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION => "Need to elevate the process to complete the operation",
            SHELL_NAP::NAP_E_CONFLICTING_ID => "The entity ID conflicts with an already registered id.",
            SHELL_NAP::COPYENGINE_E_SAME_FILE => "Source and destination file are the same",
            SHELL_NAP::NAP_E_NO_CACHED_SOH => "No cached SoH is present.",
            SHELL_NAP::COPYENGINE_E_DIFF_DIR => "Trying to rename a file into a different location, use move instead",
            SHELL_NAP::NAP_E_STILL_BOUND => "The entity is still bound to the NAP system.",
            SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST => "One source specified, multiple destinations",
            SHELL_NAP::NAP_E_NOT_REGISTERED => "The entity is not registered with the NAP system.",
            SHELL_NAP::NAP_E_NOT_INITIALIZED => "The entity is not initialized with the NAP system.",
            SHELL_NAP::NAP_E_MISMATCHED_ID => "The correlation id in the SoH-Request and SoH-Response do not match up.",
            SHELL_NAP::NAP_E_NOT_PENDING => "Completion was indicated on a request that is not currently pending.",
            SHELL_NAP::COPYENGINE_E_DEST_SUBTREE => "The destination is a sub-tree of the source",
            SHELL_NAP::NAP_E_ID_NOT_FOUND => "The NAP component's id was not found.",
            SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE => "The destination is the same folder as the source",
            SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL => "The maximum size of the connection is too small for an SoH packet.",
            SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST => "Existing destination file with same name as folder",
            SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING => "The NapAgent service is not running.",
            SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST => "Existing destination folder with same name as file",
            SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE => "File too large for destination file system",
            SHELL_NAP::NAP_E_ENTITY_DISABLED => "The entity is disabled with the NapAgent service.",
            SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL => "Destination device is full and happens to be removable",
            SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR => "Group Policy is not configured.",
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD => "Destination is a Read-Only CDRom, possibly unformatted",
            SHELL_NAP::NAP_E_TOO_MANY_CALLS => "Too many simultaneous calls.",
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD => "Destination is a Read/Write CDRom, possibly unformatted",
            SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED => "SHV configuration already existed.",
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD => "Destination is a Recordable (AudioL) CDRom, possibly unformatted",
            SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND => "SHV configuration is not found.",
            SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD => "Destination is a Read-Only DVD, possibly unformatted",
            SHELL_NAP::NAP_E_SHV_TIMEOUT => "SHV timed out on the request.",
            SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD => "Destination is a Read/Wrote DVD, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD => "Destination is a Recordable (AudioL) DVD, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD => "Source is a Read-Only CDRom, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD => "Source is a Read/Write CDRom, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD => "Source is a Recordable (AudioL) CDRom, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD => "Source is a Read-Only DVD, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD => "Source is a Read/Wrote DVD, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD => "Source is a Recordable (AudioL) DVD, possibly unformatted",
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC => "Invalid source path",
            SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST => "Invalid destination path",
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC => "Source Files within folders where the overall path is longer than MAX_PATH",
            SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST => "Destination files would be within folders where the overall path is longer than MAX_PATH",
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC => "Source is a root directory, cannot be moved or renamed",
            SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST => "Destination is a root directory, cannot be renamed",
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC => "Security problem on source",
            SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST => "Security problem on destination",
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC => "Source file does not exist, or is unavailable",
            SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST => "Destination file does not exist, or is unavailable",
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC => "Source file is on a disconnected network location",
            SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST => "Destination file is on a disconnected network location",
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC => "Sharing Violation on source",
            SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST => "Sharing Violation on destination",
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL => "Destination exists, cannot replace",
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY => "Destination with read-only attribute exists, cannot replace",
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM => "Destination with system attribute exists, cannot replace",
            SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER => "Destination folder exists, cannot replace",
            SHELL_NAP::COPYENGINE_E_STREAM_LOSS => "Secondary Stream information would be lost",
            SHELL_NAP::COPYENGINE_E_EA_LOSS => "Extended Attributes would be lost",
            SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS => "Property would be lost",
            SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS => "Properties would be lost",
            SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS => "Encryption would be lost",
            SHELL_NAP::COPYENGINE_E_DISK_FULL => "Entire operation likely won't fit",
            SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN => "Entire operation likely won't fit, clean-up wizard available",
            SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED => "Volume does not support Extended Attributes",
            SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE => "Can't reach source folder",
            SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR => "Description is missing",
            SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE => "Recycling not available (usually turned offL)",
            SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG => "Item is too large for the recycle-bin",
            SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG => "Folder is too deep to fit in the recycle-bin",
            SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND => "Recycle bin could not be found or is unavailable",
            SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG => "Name of the new file being created is too long",
            SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG => "Name of the new folder being created is too long",
            SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY => "The directory being processed is not empty",
            SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT => "A Fat drive cannot only store and rename a limited number of items on the root.",
            SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY => "The item cannot be modified because it is set to readonly.",
            SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE => "The server redirected the download request to a web page.",
            SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE => "The server returned data with an unexpected MIME type or extension.",
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE => "The item is unavailable currently due to no internet connectivity",
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN => "The item cannot be moved out of the recycle bin, can perform other operations like restored/delete",
            SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER => "The item cannot be moved from a grouped folder to another shared folder",
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR => "The item is unavailable currently due to storage provider being in error state",
            SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED => "The item is unavailable currently due to storage provider being paused",
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT => "The file can only be copied if the user consents to override the EDP block",
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY => "The file cannot be copied per EDP policy",
            SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => "The file can be copied as personal if the user consents to override the EDP block",
            SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => "The file can only be copied as work protected per EDP policy",
            SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE => "The file can be copied as personal if the user consents to override the EDP block",
            SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE => "The file can only be copied as work protected per EDP policy",
            SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE => "The item requested is in the negative net parsing cache",
            SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION => "for returned by command delegates to indicate that they did no work",
            SHELL_NAP::SHELL_E_WRONG_BITDEPTH => "returned when trying to create a thumbnail extractor at too low a bitdepth for high fidelity",
            SHELL_NAP::LINK_E_DELETE => "returned from IShellLink::Resolve when SLR_OFFER_DELETE_WITHOUT_FILE is passed and the user requested to delete the item",
            SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE => "returned from IAppItemsStateModify to indicate a commit failed because there is newer version already available",
            SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED => "The placeholder file or property store isn't initialized.",
            SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH => "The sync engine detected that the local placeholder file's version doesn't match the latest version.",
            SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT => "The placeholder platform timed out waiting for a stream resolver call that didn't complete in time.",
            SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND => "The placeholder platform cannot find the storage provider for the placeholder.",
            SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED => "Camera Roll: The provided image didn't require downsampling because it was small enough already",
            SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION => "Description is missing",
            SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION => "Description is missing",
            SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE => "User Tile: Unsupported file type",
            SHELL_NAP::E_USERTILE_CHANGEDISABLED => "User Tile: Indicates that the picture was not set because the AccountPictureChangeEnabled property is disabled, or the user cancelled the consent prompt.",
            SHELL_NAP::E_USERTILE_LARGEORDYNAMIC => "User Tile: Indicates that the picture was not set because the picture was too large.",
            SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE => "User Tile: Indicates that the video was not set because of its frame size was too large.",
            SHELL_NAP::E_USERTILE_FILESIZE => "User Tile: Indicates the picture was not set because the file size was too large.",
            SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED => "The maximum number of items for the access list has been reached. An item must be removed before another item is added.",
            SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE => "Cannot access Homegroup. Homegroup may not be set up or may have encountered an error.",
            SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT => "Immersive Accessibility Docking Service :",
            SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED => "Immersive Accessibility Docking Service :",
            SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE => "Immersive Shell Startup: An immersive shell component failed to start correctly",
            SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE => "Shell Service Host Startup: A shell service host component failed to start correctly",
            SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE => "Tile notifications: Failure to initialize the notification platform",
            SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW => "This app can't start because the screen resolution is below 1024x768. Choose a higher screen resolution and then try again.",
            SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED => "This app can't be activated from an elevated context.",
            SHELL_NAP::E_UAC_DISABLED => "This app can't be activated when UAC is disabled.",
            SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED => "This app can't be activated by the Built-in Administrator.",
            SHELL_NAP::E_APPLICATION_NOT_REGISTERED => "This app does not support the contract specified or is not installed.",
            SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION => "This app has multiple extensions registered to support the specified contract. Activation by AppUserModelId is ambiguous.",
            SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY => "This app's package family has more than one package installed. This is not supported.",
            SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING => "The app manager is required to activate applications, but is not running.",
            SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT => "The app didn't start in the required time.",
            SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE => "The app didn't start.",
            SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR => "This app failed to launch because of an issue with its license. Please try again in a moment.",
            SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED => "This app failed to launch because its trial license has expired.",
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED => "Please choose a folder on a drive that's formatted with the NTFS file system.",
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP => "This location is already being used. Please choose a different location.",
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX => "This location cannot be indexed. Please choose a different location.",
            SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED => "Sorry, the action couldn't be completed because the file hasn't finished uploading. Try again later.",
            SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL => "Sorry, the action couldn't be completed.",
            SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED => "This content can only be moved to a folder. To move the content to this drive, please choose or create a folder.",
            SHELL_NAP::E_SHELL_EXTENSION_BLOCKED => "Description is missing",
            SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED => "Description is missing",
        }
    }

    pub fn from_name(name: &str) -> SHELL_NAP {
        return match name {
            "COPYENGINE_S_YES" => SHELL_NAP::COPYENGINE_S_YES,
            "COPYENGINE_S_NOT_HANDLED" => SHELL_NAP::COPYENGINE_S_NOT_HANDLED,
            "COPYENGINE_S_USER_RETRY" => SHELL_NAP::COPYENGINE_S_USER_RETRY,
            "COPYENGINE_S_USER_IGNORED" => SHELL_NAP::COPYENGINE_S_USER_IGNORED,
            "COPYENGINE_S_MERGE" => SHELL_NAP::COPYENGINE_S_MERGE,
            "COPYENGINE_S_DONT_PROCESS_CHILDREN" => SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN,
            "COPYENGINE_S_ALREADY_DONE" => SHELL_NAP::COPYENGINE_S_ALREADY_DONE,
            "COPYENGINE_S_PENDING" => SHELL_NAP::COPYENGINE_S_PENDING,
            "COPYENGINE_S_KEEP_BOTH" => SHELL_NAP::COPYENGINE_S_KEEP_BOTH,
            "NAP_S_CERT_ALREADY_PRESENT" => SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT,
            "COPYENGINE_S_CLOSE_PROGRAM" => SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM,
            "COPYENGINE_S_COLLISIONRESOLVED" => SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED,
            "COPYENGINE_S_PROGRESS_PAUSE" => SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE,
            "S_STORE_LAUNCHED_FOR_REMEDIATION" => SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION,
            "S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG" => SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG,
            "COPYENGINE_E_USER_CANCELLED" => SHELL_NAP::COPYENGINE_E_USER_CANCELLED,
            "NAP_E_INVALID_PACKET" => SHELL_NAP::NAP_E_INVALID_PACKET,
            "COPYENGINE_E_CANCELLED" => SHELL_NAP::COPYENGINE_E_CANCELLED,
            "NAP_E_MISSING_SOH" => SHELL_NAP::NAP_E_MISSING_SOH,
            "COPYENGINE_E_REQUIRES_ELEVATION" => SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION,
            "NAP_E_CONFLICTING_ID" => SHELL_NAP::NAP_E_CONFLICTING_ID,
            "COPYENGINE_E_SAME_FILE" => SHELL_NAP::COPYENGINE_E_SAME_FILE,
            "NAP_E_NO_CACHED_SOH" => SHELL_NAP::NAP_E_NO_CACHED_SOH,
            "COPYENGINE_E_DIFF_DIR" => SHELL_NAP::COPYENGINE_E_DIFF_DIR,
            "NAP_E_STILL_BOUND" => SHELL_NAP::NAP_E_STILL_BOUND,
            "COPYENGINE_E_MANY_SRC_1_DEST" => SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST,
            "NAP_E_NOT_REGISTERED" => SHELL_NAP::NAP_E_NOT_REGISTERED,
            "NAP_E_NOT_INITIALIZED" => SHELL_NAP::NAP_E_NOT_INITIALIZED,
            "NAP_E_MISMATCHED_ID" => SHELL_NAP::NAP_E_MISMATCHED_ID,
            "NAP_E_NOT_PENDING" => SHELL_NAP::NAP_E_NOT_PENDING,
            "COPYENGINE_E_DEST_SUBTREE" => SHELL_NAP::COPYENGINE_E_DEST_SUBTREE,
            "NAP_E_ID_NOT_FOUND" => SHELL_NAP::NAP_E_ID_NOT_FOUND,
            "COPYENGINE_E_DEST_SAME_TREE" => SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE,
            "NAP_E_MAXSIZE_TOO_SMALL" => SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL,
            "COPYENGINE_E_FLD_IS_FILE_DEST" => SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST,
            "NAP_E_SERVICE_NOT_RUNNING" => SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING,
            "COPYENGINE_E_FILE_IS_FLD_DEST" => SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST,
            "COPYENGINE_E_FILE_TOO_LARGE" => SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE,
            "NAP_E_ENTITY_DISABLED" => SHELL_NAP::NAP_E_ENTITY_DISABLED,
            "COPYENGINE_E_REMOVABLE_FULL" => SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL,
            "NAP_E_NETSH_GROUPPOLICY_ERROR" => SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR,
            "COPYENGINE_E_DEST_IS_RO_CD" => SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD,
            "NAP_E_TOO_MANY_CALLS" => SHELL_NAP::NAP_E_TOO_MANY_CALLS,
            "COPYENGINE_E_DEST_IS_RW_CD" => SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD,
            "NAP_E_SHV_CONFIG_EXISTED" => SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED,
            "COPYENGINE_E_DEST_IS_R_CD" => SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD,
            "NAP_E_SHV_CONFIG_NOT_FOUND" => SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND,
            "COPYENGINE_E_DEST_IS_RO_DVD" => SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD,
            "NAP_E_SHV_TIMEOUT" => SHELL_NAP::NAP_E_SHV_TIMEOUT,
            "COPYENGINE_E_DEST_IS_RW_DVD" => SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD,
            "COPYENGINE_E_DEST_IS_R_DVD" => SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD,
            "COPYENGINE_E_SRC_IS_RO_CD" => SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD,
            "COPYENGINE_E_SRC_IS_RW_CD" => SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD,
            "COPYENGINE_E_SRC_IS_R_CD" => SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD,
            "COPYENGINE_E_SRC_IS_RO_DVD" => SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD,
            "COPYENGINE_E_SRC_IS_RW_DVD" => SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD,
            "COPYENGINE_E_SRC_IS_R_DVD" => SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD,
            "COPYENGINE_E_INVALID_FILES_SRC" => SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC,
            "COPYENGINE_E_INVALID_FILES_DEST" => SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST,
            "COPYENGINE_E_PATH_TOO_DEEP_SRC" => SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC,
            "COPYENGINE_E_PATH_TOO_DEEP_DEST" => SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST,
            "COPYENGINE_E_ROOT_DIR_SRC" => SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC,
            "COPYENGINE_E_ROOT_DIR_DEST" => SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST,
            "COPYENGINE_E_ACCESS_DENIED_SRC" => SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC,
            "COPYENGINE_E_ACCESS_DENIED_DEST" => SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST,
            "COPYENGINE_E_PATH_NOT_FOUND_SRC" => SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC,
            "COPYENGINE_E_PATH_NOT_FOUND_DEST" => SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST,
            "COPYENGINE_E_NET_DISCONNECT_SRC" => SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC,
            "COPYENGINE_E_NET_DISCONNECT_DEST" => SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST,
            "COPYENGINE_E_SHARING_VIOLATION_SRC" => SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC,
            "COPYENGINE_E_SHARING_VIOLATION_DEST" => SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST,
            "COPYENGINE_E_ALREADY_EXISTS_NORMAL" => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL,
            "COPYENGINE_E_ALREADY_EXISTS_READONLY" => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY,
            "COPYENGINE_E_ALREADY_EXISTS_SYSTEM" => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM,
            "COPYENGINE_E_ALREADY_EXISTS_FOLDER" => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER,
            "COPYENGINE_E_STREAM_LOSS" => SHELL_NAP::COPYENGINE_E_STREAM_LOSS,
            "COPYENGINE_E_EA_LOSS" => SHELL_NAP::COPYENGINE_E_EA_LOSS,
            "COPYENGINE_E_PROPERTY_LOSS" => SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS,
            "COPYENGINE_E_PROPERTIES_LOSS" => SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS,
            "COPYENGINE_E_ENCRYPTION_LOSS" => SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS,
            "COPYENGINE_E_DISK_FULL" => SHELL_NAP::COPYENGINE_E_DISK_FULL,
            "COPYENGINE_E_DISK_FULL_CLEAN" => SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN,
            "COPYENGINE_E_EA_NOT_SUPPORTED" => SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED,
            "COPYENGINE_E_CANT_REACH_SOURCE" => SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE,
            "COPYENGINE_E_RECYCLE_UNKNOWN_ERROR" => SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR,
            "COPYENGINE_E_RECYCLE_FORCE_NUKE" => SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE,
            "COPYENGINE_E_RECYCLE_SIZE_TOO_BIG" => SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG,
            "COPYENGINE_E_RECYCLE_PATH_TOO_LONG" => SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG,
            "COPYENGINE_E_RECYCLE_BIN_NOT_FOUND" => SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND,
            "COPYENGINE_E_NEWFILE_NAME_TOO_LONG" => SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG,
            "COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG" => SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG,
            "COPYENGINE_E_DIR_NOT_EMPTY" => SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY,
            "COPYENGINE_E_FAT_MAX_IN_ROOT" => SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT,
            "COPYENGINE_E_ACCESSDENIED_READONLY" => SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY,
            "COPYENGINE_E_REDIRECTED_TO_WEBPAGE" => SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE,
            "COPYENGINE_E_SERVER_BAD_FILE_TYPE" => SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE,
            "COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE" => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE,
            "COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN" => SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN,
            "COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER" => SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER,
            "COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR" => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR,
            "COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED" => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED,
            "COPYENGINE_E_REQUIRES_EDP_CONSENT" => SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT,
            "COPYENGINE_E_BLOCKED_BY_EDP_POLICY" => SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY,
            "COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE" => SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
            "COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE" => SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
            "COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE" => SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
            "COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE" => SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
            "NETCACHE_E_NEGATIVE_CACHE" => SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE,
            "EXECUTE_E_LAUNCH_APPLICATION" => SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION,
            "SHELL_E_WRONG_BITDEPTH" => SHELL_NAP::SHELL_E_WRONG_BITDEPTH,
            "LINK_E_DELETE" => SHELL_NAP::LINK_E_DELETE,
            "STORE_E_NEWER_VERSION_AVAILABLE" => SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE,
            "E_FILE_PLACEHOLDER_NOT_INITIALIZED" => SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED,
            "E_FILE_PLACEHOLDER_VERSION_MISMATCH" => SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH,
            "E_FILE_PLACEHOLDER_SERVER_TIMED_OUT" => SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT,
            "E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND" => SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND,
            "CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED" => SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED,
            "LIBRARY_E_NO_SAVE_LOCATION" => SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION,
            "LIBRARY_E_NO_ACCESSIBLE_LOCATION" => SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION,
            "E_USERTILE_UNSUPPORTEDFILETYPE" => SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE,
            "E_USERTILE_CHANGEDISABLED" => SHELL_NAP::E_USERTILE_CHANGEDISABLED,
            "E_USERTILE_LARGEORDYNAMIC" => SHELL_NAP::E_USERTILE_LARGEORDYNAMIC,
            "E_USERTILE_VIDEOFRAMESIZE" => SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE,
            "E_USERTILE_FILESIZE" => SHELL_NAP::E_USERTILE_FILESIZE,
            "FA_E_MAX_PERSISTED_ITEMS_REACHED" => SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED,
            "FA_E_HOMEGROUP_NOT_AVAILABLE" => SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE,
            "IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT" => SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT,
            "IMM_ACC_DOCKING_E_DOCKOCCUPIED" => SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED,
            "IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE" => SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE,
            "SHC_E_SHELL_COMPONENT_STARTUP_FAILURE" => SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE,
            "E_TILE_NOTIFICATIONS_PLATFORM_FAILURE" => SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE,
            "E_MONITOR_RESOLUTION_TOO_LOW" => SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW,
            "E_ELEVATED_ACTIVATION_NOT_SUPPORTED" => SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED,
            "E_UAC_DISABLED" => SHELL_NAP::E_UAC_DISABLED,
            "E_FULL_ADMIN_NOT_SUPPORTED" => SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED,
            "E_APPLICATION_NOT_REGISTERED" => SHELL_NAP::E_APPLICATION_NOT_REGISTERED,
            "E_MULTIPLE_EXTENSIONS_FOR_APPLICATION" => SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION,
            "E_MULTIPLE_PACKAGES_FOR_FAMILY" => SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY,
            "E_APPLICATION_MANAGER_NOT_RUNNING" => SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING,
            "E_APPLICATION_ACTIVATION_TIMED_OUT" => SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT,
            "E_APPLICATION_ACTIVATION_EXEC_FAILURE" => SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE,
            "E_APPLICATION_TEMPORARY_LICENSE_ERROR" => SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR,
            "E_APPLICATION_TRIAL_LICENSE_EXPIRED" => SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED,
            "E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED" => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED,
            "E_SKYDRIVE_ROOT_TARGET_OVERLAP" => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP,
            "E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX" => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX,
            "E_SKYDRIVE_FILE_NOT_UPLOADED" => SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED,
            "E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL" => SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL,
            "E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED" => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED,
            "E_SHELL_EXTENSION_BLOCKED" => SHELL_NAP::E_SHELL_EXTENSION_BLOCKED,
            "E_IMAGEFEED_CHANGEDISABLED" => SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED,
        }
    }
    pub fn from_code(code: u32) -> SHELL_NAP {
        return match code {
            0x00270001 => SHELL_NAP::COPYENGINE_S_YES,
            0x00270003 => SHELL_NAP::COPYENGINE_S_NOT_HANDLED,
            0x00270004 => SHELL_NAP::COPYENGINE_S_USER_RETRY,
            0x00270005 => SHELL_NAP::COPYENGINE_S_USER_IGNORED,
            0x00270006 => SHELL_NAP::COPYENGINE_S_MERGE,
            0x00270008 => SHELL_NAP::COPYENGINE_S_DONT_PROCESS_CHILDREN,
            0x0027000A => SHELL_NAP::COPYENGINE_S_ALREADY_DONE,
            0x0027000B => SHELL_NAP::COPYENGINE_S_PENDING,
            0x0027000C => SHELL_NAP::COPYENGINE_S_KEEP_BOTH,
            0x0027000D => SHELL_NAP::NAP_S_CERT_ALREADY_PRESENT,
            0x0027000D => SHELL_NAP::COPYENGINE_S_CLOSE_PROGRAM,
            0x0027000E => SHELL_NAP::COPYENGINE_S_COLLISIONRESOLVED,
            0x0027000F => SHELL_NAP::COPYENGINE_S_PROGRESS_PAUSE,
            0x00270258 => SHELL_NAP::S_STORE_LAUNCHED_FOR_REMEDIATION,
            0x00270259 => SHELL_NAP::S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG,
            0x80270000 => SHELL_NAP::COPYENGINE_E_USER_CANCELLED,
            0x80270001 => SHELL_NAP::NAP_E_INVALID_PACKET,
            0x80270001 => SHELL_NAP::COPYENGINE_E_CANCELLED,
            0x80270002 => SHELL_NAP::NAP_E_MISSING_SOH,
            0x80270002 => SHELL_NAP::COPYENGINE_E_REQUIRES_ELEVATION,
            0x80270003 => SHELL_NAP::NAP_E_CONFLICTING_ID,
            0x80270003 => SHELL_NAP::COPYENGINE_E_SAME_FILE,
            0x80270004 => SHELL_NAP::NAP_E_NO_CACHED_SOH,
            0x80270004 => SHELL_NAP::COPYENGINE_E_DIFF_DIR,
            0x80270005 => SHELL_NAP::NAP_E_STILL_BOUND,
            0x80270005 => SHELL_NAP::COPYENGINE_E_MANY_SRC_1_DEST,
            0x80270006 => SHELL_NAP::NAP_E_NOT_REGISTERED,
            0x80270007 => SHELL_NAP::NAP_E_NOT_INITIALIZED,
            0x80270008 => SHELL_NAP::NAP_E_MISMATCHED_ID,
            0x80270009 => SHELL_NAP::NAP_E_NOT_PENDING,
            0x80270009 => SHELL_NAP::COPYENGINE_E_DEST_SUBTREE,
            0x8027000A => SHELL_NAP::NAP_E_ID_NOT_FOUND,
            0x8027000A => SHELL_NAP::COPYENGINE_E_DEST_SAME_TREE,
            0x8027000B => SHELL_NAP::NAP_E_MAXSIZE_TOO_SMALL,
            0x8027000B => SHELL_NAP::COPYENGINE_E_FLD_IS_FILE_DEST,
            0x8027000C => SHELL_NAP::NAP_E_SERVICE_NOT_RUNNING,
            0x8027000C => SHELL_NAP::COPYENGINE_E_FILE_IS_FLD_DEST,
            0x8027000D => SHELL_NAP::COPYENGINE_E_FILE_TOO_LARGE,
            0x8027000E => SHELL_NAP::NAP_E_ENTITY_DISABLED,
            0x8027000E => SHELL_NAP::COPYENGINE_E_REMOVABLE_FULL,
            0x8027000F => SHELL_NAP::NAP_E_NETSH_GROUPPOLICY_ERROR,
            0x8027000F => SHELL_NAP::COPYENGINE_E_DEST_IS_RO_CD,
            0x80270010 => SHELL_NAP::NAP_E_TOO_MANY_CALLS,
            0x80270010 => SHELL_NAP::COPYENGINE_E_DEST_IS_RW_CD,
            0x80270011 => SHELL_NAP::NAP_E_SHV_CONFIG_EXISTED,
            0x80270011 => SHELL_NAP::COPYENGINE_E_DEST_IS_R_CD,
            0x80270012 => SHELL_NAP::NAP_E_SHV_CONFIG_NOT_FOUND,
            0x80270012 => SHELL_NAP::COPYENGINE_E_DEST_IS_RO_DVD,
            0x80270013 => SHELL_NAP::NAP_E_SHV_TIMEOUT,
            0x80270013 => SHELL_NAP::COPYENGINE_E_DEST_IS_RW_DVD,
            0x80270014 => SHELL_NAP::COPYENGINE_E_DEST_IS_R_DVD,
            0x80270015 => SHELL_NAP::COPYENGINE_E_SRC_IS_RO_CD,
            0x80270016 => SHELL_NAP::COPYENGINE_E_SRC_IS_RW_CD,
            0x80270017 => SHELL_NAP::COPYENGINE_E_SRC_IS_R_CD,
            0x80270018 => SHELL_NAP::COPYENGINE_E_SRC_IS_RO_DVD,
            0x80270019 => SHELL_NAP::COPYENGINE_E_SRC_IS_RW_DVD,
            0x8027001A => SHELL_NAP::COPYENGINE_E_SRC_IS_R_DVD,
            0x8027001B => SHELL_NAP::COPYENGINE_E_INVALID_FILES_SRC,
            0x8027001C => SHELL_NAP::COPYENGINE_E_INVALID_FILES_DEST,
            0x8027001D => SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_SRC,
            0x8027001E => SHELL_NAP::COPYENGINE_E_PATH_TOO_DEEP_DEST,
            0x8027001F => SHELL_NAP::COPYENGINE_E_ROOT_DIR_SRC,
            0x80270020 => SHELL_NAP::COPYENGINE_E_ROOT_DIR_DEST,
            0x80270021 => SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_SRC,
            0x80270022 => SHELL_NAP::COPYENGINE_E_ACCESS_DENIED_DEST,
            0x80270023 => SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_SRC,
            0x80270024 => SHELL_NAP::COPYENGINE_E_PATH_NOT_FOUND_DEST,
            0x80270025 => SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_SRC,
            0x80270026 => SHELL_NAP::COPYENGINE_E_NET_DISCONNECT_DEST,
            0x80270027 => SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_SRC,
            0x80270028 => SHELL_NAP::COPYENGINE_E_SHARING_VIOLATION_DEST,
            0x80270029 => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_NORMAL,
            0x8027002A => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_READONLY,
            0x8027002B => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_SYSTEM,
            0x8027002C => SHELL_NAP::COPYENGINE_E_ALREADY_EXISTS_FOLDER,
            0x8027002D => SHELL_NAP::COPYENGINE_E_STREAM_LOSS,
            0x8027002E => SHELL_NAP::COPYENGINE_E_EA_LOSS,
            0x8027002F => SHELL_NAP::COPYENGINE_E_PROPERTY_LOSS,
            0x80270030 => SHELL_NAP::COPYENGINE_E_PROPERTIES_LOSS,
            0x80270031 => SHELL_NAP::COPYENGINE_E_ENCRYPTION_LOSS,
            0x80270032 => SHELL_NAP::COPYENGINE_E_DISK_FULL,
            0x80270033 => SHELL_NAP::COPYENGINE_E_DISK_FULL_CLEAN,
            0x80270034 => SHELL_NAP::COPYENGINE_E_EA_NOT_SUPPORTED,
            0x80270035 => SHELL_NAP::COPYENGINE_E_CANT_REACH_SOURCE,
            0x80270035 => SHELL_NAP::COPYENGINE_E_RECYCLE_UNKNOWN_ERROR,
            0x80270036 => SHELL_NAP::COPYENGINE_E_RECYCLE_FORCE_NUKE,
            0x80270037 => SHELL_NAP::COPYENGINE_E_RECYCLE_SIZE_TOO_BIG,
            0x80270038 => SHELL_NAP::COPYENGINE_E_RECYCLE_PATH_TOO_LONG,
            0x8027003A => SHELL_NAP::COPYENGINE_E_RECYCLE_BIN_NOT_FOUND,
            0x8027003B => SHELL_NAP::COPYENGINE_E_NEWFILE_NAME_TOO_LONG,
            0x8027003C => SHELL_NAP::COPYENGINE_E_NEWFOLDER_NAME_TOO_LONG,
            0x8027003D => SHELL_NAP::COPYENGINE_E_DIR_NOT_EMPTY,
            0x8027003E => SHELL_NAP::COPYENGINE_E_FAT_MAX_IN_ROOT,
            0x8027003F => SHELL_NAP::COPYENGINE_E_ACCESSDENIED_READONLY,
            0x80270040 => SHELL_NAP::COPYENGINE_E_REDIRECTED_TO_WEBPAGE,
            0x80270041 => SHELL_NAP::COPYENGINE_E_SERVER_BAD_FILE_TYPE,
            0x80270042 => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_UNAVAILABLE,
            0x80270043 => SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_FROM_RECYCLE_BIN,
            0x80270044 => SHELL_NAP::COPYENGINE_E_CANNOT_MOVE_SHARED_FOLDER,
            0x80270045 => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_ERROR,
            0x80270046 => SHELL_NAP::COPYENGINE_E_INTERNET_ITEM_STORAGE_PROVIDER_PAUSED,
            0x80270047 => SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT,
            0x80270048 => SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_POLICY,
            0x80270049 => SHELL_NAP::COPYENGINE_E_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
            0x8027004A => SHELL_NAP::COPYENGINE_E_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
            0x8027004B => SHELL_NAP::COPYENGINE_E_RMS_REQUIRES_EDP_CONSENT_FOR_REMOVABLE_DRIVE,
            0x8027004C => SHELL_NAP::COPYENGINE_E_RMS_BLOCKED_BY_EDP_FOR_REMOVABLE_DRIVE,
            0x80270100 => SHELL_NAP::NETCACHE_E_NEGATIVE_CACHE,
            0x80270101 => SHELL_NAP::EXECUTE_E_LAUNCH_APPLICATION,
            0x80270102 => SHELL_NAP::SHELL_E_WRONG_BITDEPTH,
            0x80270103 => SHELL_NAP::LINK_E_DELETE,
            0x80270104 => SHELL_NAP::STORE_E_NEWER_VERSION_AVAILABLE,
            0x80270110 => SHELL_NAP::E_FILE_PLACEHOLDER_NOT_INITIALIZED,
            0x80270111 => SHELL_NAP::E_FILE_PLACEHOLDER_VERSION_MISMATCH,
            0x80270112 => SHELL_NAP::E_FILE_PLACEHOLDER_SERVER_TIMED_OUT,
            0x80270113 => SHELL_NAP::E_FILE_PLACEHOLDER_STORAGEPROVIDER_NOT_FOUND,
            0x80270120 => SHELL_NAP::CAMERAROLL_E_NO_DOWNSAMPLING_REQUIRED,
            0x80270200 => SHELL_NAP::LIBRARY_E_NO_SAVE_LOCATION,
            0x80270201 => SHELL_NAP::LIBRARY_E_NO_ACCESSIBLE_LOCATION,
            0x80270210 => SHELL_NAP::E_USERTILE_UNSUPPORTEDFILETYPE,
            0x80270211 => SHELL_NAP::E_USERTILE_CHANGEDISABLED,
            0x80270212 => SHELL_NAP::E_USERTILE_LARGEORDYNAMIC,
            0x80270213 => SHELL_NAP::E_USERTILE_VIDEOFRAMESIZE,
            0x80270214 => SHELL_NAP::E_USERTILE_FILESIZE,
            0x80270220 => SHELL_NAP::FA_E_MAX_PERSISTED_ITEMS_REACHED,
            0x80270222 => SHELL_NAP::FA_E_HOMEGROUP_NOT_AVAILABLE,
            0x80270230 => SHELL_NAP::IMM_ACC_DOCKING_E_INSUFFICIENTHEIGHT,
            0x80270231 => SHELL_NAP::IMM_ACC_DOCKING_E_DOCKOCCUPIED,
            0x80270233 => SHELL_NAP::IMSC_E_SHELL_COMPONENT_STARTUP_FAILURE,
            0x80270234 => SHELL_NAP::SHC_E_SHELL_COMPONENT_STARTUP_FAILURE,
            0x80270249 => SHELL_NAP::E_TILE_NOTIFICATIONS_PLATFORM_FAILURE,
            0x80270250 => SHELL_NAP::E_MONITOR_RESOLUTION_TOO_LOW,
            0x80270251 => SHELL_NAP::E_ELEVATED_ACTIVATION_NOT_SUPPORTED,
            0x80270252 => SHELL_NAP::E_UAC_DISABLED,
            0x80270253 => SHELL_NAP::E_FULL_ADMIN_NOT_SUPPORTED,
            0x80270254 => SHELL_NAP::E_APPLICATION_NOT_REGISTERED,
            0x80270255 => SHELL_NAP::E_MULTIPLE_EXTENSIONS_FOR_APPLICATION,
            0x80270256 => SHELL_NAP::E_MULTIPLE_PACKAGES_FOR_FAMILY,
            0x80270257 => SHELL_NAP::E_APPLICATION_MANAGER_NOT_RUNNING,
            0x8027025A => SHELL_NAP::E_APPLICATION_ACTIVATION_TIMED_OUT,
            0x8027025B => SHELL_NAP::E_APPLICATION_ACTIVATION_EXEC_FAILURE,
            0x8027025C => SHELL_NAP::E_APPLICATION_TEMPORARY_LICENSE_ERROR,
            0x8027025D => SHELL_NAP::E_APPLICATION_TRIAL_LICENSE_EXPIRED,
            0x80270260 => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED,
            0x80270261 => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_OVERLAP,
            0x80270262 => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX,
            0x80270263 => SHELL_NAP::E_SKYDRIVE_FILE_NOT_UPLOADED,
            0x80270264 => SHELL_NAP::E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL,
            0x80270265 => SHELL_NAP::E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED,
            0x80270301 => SHELL_NAP::E_SHELL_EXTENSION_BLOCKED,
            0x80270310 => SHELL_NAP::E_IMAGEFEED_CHANGEDISABLED,
        }
    }
}
