/*
 * Copyright 2023 Stanislav Mikhailov (xavetar)
 *
 * Licensed under the Creative Commons Zero v1.0 Universal (CC0) License.
 * You may obtain a copy of the License at
 *
 *     http://creativecommons.org/publicdomain/zero/1.0/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the CC0 license is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// It is strictly forbidden to use the from_code method, respected Microsoft decided to define
// duplicate codes, but by defining different constant names, therefore, when using these codes,
// it is mandatory to use through from_name, and not from_code. Otherwise, it may cause undefined
// behavior or an unknown exception. Because one code corresponds to several constants.

use super::{RawError};

#[derive(Clone, Debug, Copy, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum USERMODE_VIRTUALIZATION {
    ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED,
    HCS_E_TERMINATED_DURING_START,
    HCS_E_IMAGE_MISMATCH,
    HCS_E_HYPERV_NOT_INSTALLED,
    HCS_E_INVALID_STATE,
    HCS_E_UNEXPECTED_EXIT,
    HCS_E_TERMINATED,
    HCS_E_CONNECT_FAILED,
    HCS_E_CONNECTION_TIMEOUT,
    HCS_E_CONNECTION_CLOSED,
    HCS_E_UNKNOWN_MESSAGE,
    HCS_E_UNSUPPORTED_PROTOCOL_VERSION,
    HCS_E_INVALID_JSON,
    HCS_E_SYSTEM_NOT_FOUND,
    HCS_E_SYSTEM_ALREADY_EXISTS,
    HCS_E_SYSTEM_ALREADY_STOPPED,
    HCS_E_PROTOCOL_ERROR,
    HCS_E_INVALID_LAYER,
    HCS_E_WINDOWS_INSIDER_REQUIRED,
    HCS_E_SERVICE_NOT_AVAILABLE,
    HCS_E_OPERATION_NOT_STARTED,
    HCS_E_OPERATION_ALREADY_STARTED,
    HCS_E_OPERATION_PENDING,
    HCS_E_OPERATION_TIMEOUT,
    HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET,
    HCS_E_OPERATION_RESULT_ALLOCATION_FAILED,
    HCS_E_ACCESS_DENIED,
    HCS_E_GUEST_CRITICAL_ERROR,
    HCS_E_PROCESS_INFO_NOT_AVAILABLE,
    HCS_E_SERVICE_DISCONNECT,
    HCS_E_PROCESS_ALREADY_STOPPED,
    HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION,
    HCS_E_OPERATION_ALREADY_CANCELLED,
    WHV_E_UNKNOWN_CAPABILITY,
    WHV_E_INSUFFICIENT_BUFFER,
    WHV_E_UNKNOWN_PROPERTY,
    WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG,
    WHV_E_INVALID_PARTITION_CONFIG,
    WHV_E_GPA_RANGE_NOT_FOUND,
    WHV_E_VP_ALREADY_EXISTS,
    WHV_E_VP_DOES_NOT_EXIST,
    WHV_E_INVALID_VP_STATE,
    WHV_E_INVALID_VP_REGISTER_NAME,
    WHV_E_UNSUPPORTED_PROCESSOR_CONFIG,
    ERROR_VID_DUPLICATE_HANDLER,
    ERROR_VID_TOO_MANY_HANDLERS,
    ERROR_VID_QUEUE_FULL,
    ERROR_VID_HANDLER_NOT_PRESENT,
    ERROR_VID_INVALID_OBJECT_NAME,
    ERROR_VID_PARTITION_NAME_TOO_LONG,
    ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG,
    ERROR_VID_PARTITION_ALREADY_EXISTS,
    ERROR_VID_PARTITION_DOES_NOT_EXIST,
    ERROR_VID_PARTITION_NAME_NOT_FOUND,
    ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS,
    ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT,
    ERROR_VID_MB_STILL_REFERENCED,
    ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED,
    ERROR_VID_INVALID_NUMA_SETTINGS,
    ERROR_VID_INVALID_NUMA_NODE_INDEX,
    ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED,
    ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE,
    ERROR_VID_PAGE_RANGE_OVERFLOW,
    ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE,
    ERROR_VID_INVALID_GPA_RANGE_HANDLE,
    ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE,
    ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED,
    ERROR_VID_INVALID_PPM_HANDLE,
    ERROR_VID_MBPS_ARE_LOCKED,
    ERROR_VID_MESSAGE_QUEUE_CLOSED,
    ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED,
    ERROR_VID_STOP_PENDING,
    ERROR_VID_INVALID_PROCESSOR_STATE,
    ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT,
    ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED,
    ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET,
    ERROR_VID_MMIO_RANGE_DESTROYED,
    ERROR_VID_INVALID_CHILD_GPA_PAGE_SET,
    ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED,
    ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL,
    ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE,
    ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT,
    ERROR_VID_SAVED_STATE_CORRUPT,
    ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM,
    ERROR_VID_SAVED_STATE_INCOMPATIBLE,
    ERROR_VID_VTL_ACCESS_DENIED,
    ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE,
    ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER,
    ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT,
    ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED,
    ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW,
    ERROR_VID_PROCESS_ALREADY_SET,
    ERROR_VMCOMPUTE_TERMINATED_DURING_START,
    ERROR_VMCOMPUTE_IMAGE_MISMATCH,
    ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED,
    ERROR_VMCOMPUTE_OPERATION_PENDING,
    ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS,
    ERROR_VMCOMPUTE_INVALID_STATE,
    ERROR_VMCOMPUTE_UNEXPECTED_EXIT,
    ERROR_VMCOMPUTE_TERMINATED,
    ERROR_VMCOMPUTE_CONNECT_FAILED,
    ERROR_VMCOMPUTE_TIMEOUT,
    ERROR_VMCOMPUTE_CONNECTION_CLOSED,
    ERROR_VMCOMPUTE_UNKNOWN_MESSAGE,
    ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION,
    ERROR_VMCOMPUTE_INVALID_JSON,
    ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND,
    ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS,
    ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED,
    ERROR_VMCOMPUTE_PROTOCOL_ERROR,
    ERROR_VMCOMPUTE_INVALID_LAYER,
    ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED,
    ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND,
    ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND,
    ERROR_VSMB_SAVED_STATE_CORRUPT,
    VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND,
    VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND,
    VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE,
    VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED,
    VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND,
    VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED,
    VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE,
    VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED,
    ERROR_DM_OPERATION_LIMIT_EXCEEDED,
}

impl USERMODE_VIRTUALIZATION {
    pub fn code(&self) -> u32 {
        return match self {
            USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED => 0x80370001 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START => 0x80370100 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH => 0x80370101 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED => 0x80370102 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE => 0x80370105 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT => 0x80370106 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED => 0x80370107 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED => 0x80370108 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT => 0x80370109 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED => 0x8037010A as u32,
            USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE => 0x8037010B as u32,
            USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION => 0x8037010C as u32,
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON => 0x8037010D as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND => 0x8037010E as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS => 0x8037010F as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED => 0x80370110 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR => 0x80370111 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER => 0x80370112 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED => 0x80370113 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE => 0x80370114 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED => 0x80370115 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED => 0x80370116 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING => 0x80370117 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT => 0x80370118 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET => 0x80370119 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED => 0x8037011A as u32,
            USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED => 0x8037011B as u32,
            USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR => 0x8037011C as u32,
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE => 0x8037011D as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT => 0x8037011E as u32,
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED => 0x8037011F as u32,
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION => 0x80370120 as u32,
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED => 0x80370121 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY => 0x80370300 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER => 0x80370301 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY => 0x80370302 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG => 0x80370303 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG => 0x80370304 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND => 0x80370305 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS => 0x80370306 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST => 0x80370307 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE => 0x80370308 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME => 0x80370309 as u32,
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG => 0x80370310 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER => 0xC0370001 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS => 0xC0370002 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL => 0xC0370003 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT => 0xC0370004 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME => 0xC0370005 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG => 0xC0370006 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG => 0xC0370007 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS => 0xC0370008 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST => 0xC0370009 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND => 0xC037000A as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS => 0xC037000B as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT => 0xC037000C as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED => 0xC037000D as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED => 0xC037000E as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS => 0xC037000F as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX => 0xC0370010 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED => 0xC0370011 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE => 0xC0370012 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW => 0xC0370013 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE => 0xC0370014 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE => 0xC0370015 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE => 0xC0370016 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED => 0xC0370017 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE => 0xC0370018 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED => 0xC0370019 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED => 0xC037001A as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED => 0xC037001B as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING => 0xC037001C as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE => 0xC037001D as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT => 0xC037001E as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED => 0xC037001F as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET => 0xC0370020 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED => 0xC0370021 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET => 0xC0370022 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED => 0xC0370023 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL => 0xC0370024 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE => 0xC0370025 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT => 0xC0370026 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT => 0xC0370027 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM => 0xC0370028 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE => 0xC0370029 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED => 0xC037002A as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE => 0xC037002B as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER => 0xC037002C as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT => 0xC037002D as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED => 0xC037002E as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW => 0xC037002F as u32,
            USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET => 0xC0370030 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START => 0xC0370100 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH => 0xC0370101 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED => 0xC0370102 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING => 0xC0370103 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS => 0xC0370104 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE => 0xC0370105 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT => 0xC0370106 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED => 0xC0370107 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED => 0xC0370108 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT => 0xC0370109 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED => 0xC037010A as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE => 0xC037010B as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION => 0xC037010C as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON => 0xC037010D as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND => 0xC037010E as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS => 0xC037010F as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED => 0xC0370110 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR => 0xC0370111 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER => 0xC0370112 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED => 0xC0370113 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND => 0xC0370200 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND => 0xC0370400 as u32,
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT => 0xC0370401 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND => 0xC0370500 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND => 0xC0370501 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE => 0xC0370502 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED => 0xC0370503 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND => 0xC0370504 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED => 0xC0370505 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE => 0xC0370506 as u32,
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED => 0xC0370509 as u32,
            USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED => 0xC0370600 as u32,
        }
    }

    pub fn error(&self) -> RawError {
        return match self {
            USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED),
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START),
            USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH),
            USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED),
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE),
            USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT),
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_TERMINATED),
            USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED),
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT),
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED),
            USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE),
            USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION),
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON),
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND),
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS),
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED),
            USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR),
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER),
            USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED),
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED),
            USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED),
            USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR),
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE),
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT),
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED),
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION),
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED => RawError::Kind(USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED),
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY),
            USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER),
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY),
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG),
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG),
            USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND),
            USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS),
            USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST),
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE),
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME),
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG => RawError::Kind(USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG),
            USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER),
            USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS),
            USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL),
            USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME),
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG),
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG),
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS),
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST),
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND),
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS),
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT),
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED),
            USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX),
            USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE),
            USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE),
            USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE),
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE),
            USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED),
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED),
            USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED),
            USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE),
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT),
            USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED),
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET),
            USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET),
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED),
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL),
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE),
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT),
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT),
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM),
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE),
            USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE),
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER),
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT),
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED),
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW),
            USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER),
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED),
            USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND),
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND),
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE),
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED => RawError::Kind(USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED),
            USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED => RawError::Kind(USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED),
        }
    }

    pub fn description(&self) -> &'static str {
        return match self {
            USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED => "A virtual machine is running with its memory allocated across multiple NUMA nodes. This does not indicate a problem unless the performance of your virtual machine is unusually slow. If you are experiencing performance problems, you may need to modify the NUMA configuration.",
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START => "The virtual machine or container exited unexpectedly while starting.",
            USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH => "The container operating system does not match the host operating system.",
            USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED => "The virtual machine could not be started because a required feature is not installed.",
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE => "The requested virtual machine or container operation is not valid in the current state.",
            USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT => "The virtual machine or container exited unexpectedly.",
            USERMODE_VIRTUALIZATION::HCS_E_TERMINATED => "The virtual machine or container was forcefully exited.",
            USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED => "A connection could not be established with the container or virtual machine.",
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT => "The operation timed out because a response was not received from the virtual machine or container.",
            USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED => "The connection with the virtual machine or container was closed.",
            USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE => "An unknown internal message was received by the virtual machine or container.",
            USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION => "The virtual machine or container does not support an available version of the communication protocol with the host.",
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON => "The virtual machine or container JSON document is invalid.",
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND => "A virtual machine or container with the specified identifier does not exist.",
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS => "A virtual machine or container with the specified identifier already exists.",
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED => "The virtual machine or container with the specified identifier is not running.",
            USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR => "A communication protocol error has occurred between the virtual machine or container and the host.",
            USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER => "The container image contains a layer with an unrecognized format.",
            USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED => "To use this container image, you must join the Windows Insider Program. Please see https://go.microsoft.com/fwlink/?linkid=850659 for more information.",
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE => "The operation could not be started because a required feature is not installed.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED => "The operation has not started.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED => "The operation is already running.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING => "The operation is still running.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT => "The operation did not complete in time.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET => "An event callback has already been registered on this handle.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED => "Not enough memory available to return the result of the operation.",
            USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED => "Insufficient privileges. Only administrators or users that are members of the Hyper-V Administrators user group are permitted to access virtual machines or containers. To add yourself to the Hyper-V Administrators user group, please see https://aka.ms/hcsadmin for more information.",
            USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR => "The virtual machine or container reported a critical error and was stopped or restarted.",
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE => "The process information is not available.",
            USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT => "The host compute system service has disconnected unexpectedly.",
            USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED => "The process has already exited.",
            USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION => "The virtual machine or container is not configured to perform the operation.",
            USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED => "The operation has already been cancelled.",
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY => "The specified capability does not exist.",
            USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER => "The specified buffer is too small for the requested data.",
            USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY => "The specified property does not exist.",
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG => "The configuration of the hypervisor on this system is not supported.",
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG => "The configuration of the partition is not valid.",
            USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND => "The specified GPA range was not found.",
            USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS => "A virtual processor with the specified index already exists.",
            USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST => "A virtual processor with the specified index does not exist.",
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE => "The virtual processor is not in the correct state to perform the requested operation.",
            USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME => "A virtual processor register with the specified name does not exist.",
            USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG => "The Windows Hypervisor Platform is not supported due to a processor limitation.",
            USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER => "The handler for the virtualization infrastructure driver is already registered. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS => "The number of registered handlers for the virtualization infrastructure driver exceeded the maximum. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL => "The message queue for the virtualization infrastructure driver is full and cannot accept new messages. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT => "No handler exists to handle the message for the virtualization infrastructure driver. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME => "The name of the partition or message queue for the virtualization infrastructure driver is invalid. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG => "The partition name of the virtualization infrastructure driver exceeds the maximum.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG => "The message queue name of the virtualization infrastructure driver exceeds the maximum.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS => "Cannot create the partition for the virtualization infrastructure driver because another partition with the same name already exists.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST => "The virtualization infrastructure driver has encountered an error. The requested partition does not exist. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND => "The virtualization infrastructure driver has encountered an error. Could not find the requested partition. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS => "A message queue with the same name already exists for the virtualization infrastructure driver.",
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT => "The memory block page for the virtualization infrastructure driver cannot be mapped because the page map limit has been reached. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED => "The memory block for the virtualization infrastructure driver is still being used and cannot be destroyed.",
            USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED => "Cannot unlock the page array for the guest operating system memory address because it does not match a previous lock request. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS => "The non-uniform memory access (NUMA) node settings do not match the system NUMA topology. In order to start the virtual machine, you will need to modify the NUMA configuration.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX => "The non-uniform memory access (NUMA) node index does not match a valid index in the system NUMA topology.",
            USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED => "The memory block for the virtualization infrastructure driver is already associated with a message queue.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE => "The handle is not a valid memory block handle for the virtualization infrastructure driver.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW => "The request exceeded the memory block page limit for the virtualization infrastructure driver. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE => "The handle is not a valid message queue handle for the virtualization infrastructure driver.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE => "The handle is not a valid page range handle for the virtualization infrastructure driver.",
            USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE => "Cannot install client notifications because no message queue for the virtualization infrastructure driver is associated with the memory block.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED => "The request to lock or map a memory block page failed because the virtualization infrastructure driver memory block limit has been reached. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE => "The handle is not a valid parent partition mapping handle for the virtualization infrastructure driver.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED => "Notifications cannot be created on the memory block because it is use.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED => "The message queue for the virtualization infrastructure driver has been closed. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED => "Cannot add a virtual processor to the partition because the maximum has been reached.",
            USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING => "Cannot stop the virtual processor immediately because of a pending intercept.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE => "Invalid state for the virtual processor. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT => "The maximum number of kernel mode clients for the virtualization infrastructure driver has been reached. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED => "This kernel mode interface for the virtualization infrastructure driver has already been initialized. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET => "Cannot set or reset the memory block property more than once for the virtualization infrastructure driver. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED => "The memory mapped I/O for this page range no longer exists. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET => "The lock or unlock request uses an invalid guest operating system memory address. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED => "Cannot destroy or reuse the reserve page set for the virtualization infrastructure driver because it is in use. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL => "The reserve page set for the virtualization infrastructure driver is too small to use in the lock request. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE => "Cannot lock or map the memory block page for the virtualization infrastructure driver because it has already been locked using a reserve page set page. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT => "Cannot create the memory block for the virtualization infrastructure driver because the requested number of pages exceeded the limit. Restarting the virtual machine may fix the problem. If the problem persists, try restarting the physical computer.",
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT => "Cannot restore this virtual machine because the saved state data cannot be read. Delete the saved state data and then try to start the virtual machine.",
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM => "Cannot restore this virtual machine because an item read from the saved state data is not recognized. Delete the saved state data and then try to start the virtual machine.",
            USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE => "Cannot restore this virtual machine to the saved state because of hypervisor incompatibility. Delete the saved state data and then try to start the virtual machine.",
            USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED => "The specified VTL does not have the permission to access the resource.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE => "Failed to allocate backing memory due to insufficient memory resources.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER => "Failed to allocate memory for the physical buffer used to back certain internal structures.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT => "Failed to allocate memory to be deposited in the hypervisor.",
            USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED => "Memory type not supported for requested operation.",
            USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW => "Failed to withdraw memory.",
            USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET => "The process has already been set.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START => "The virtual machine or container exited unexpectedly while starting.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH => "The container operating system does not match the host operating system.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED => "The virtual machine could not be started because a required feature is not installed.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING => "The call to start an asynchronous operation succeeded and the operation is performed in the background.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS => "The supported number of notification callbacks has been exceeded.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE => "The requested virtual machine or container operation is not valid in the current state.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT => "The virtual machine or container exited unexpectedly.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED => "The virtual machine or container was forcefully exited.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED => "A connection could not be established with the container or virtual machine.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT => "The operation timed out because a response was not received from the virtual machine or container.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED => "The connection with the virtual machine or container was closed.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE => "An unknown internal message was received by the virtual machine or container.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION => "The virtual machine or container does not support an available version of the communication protocol with the host.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON => "The virtual machine or container JSON document is invalid.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND => "A virtual machine or container with the specified identifier does not exist.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS => "A virtual machine or container with the specified identifier already exists.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED => "The virtual machine or container with the specified identifier is not running.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR => "A communication protocol error has occurred between the virtual machine or container and the host.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER => "The container image contains a layer with an unrecognized format.",
            USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED => "To use this container image, you must join the Windows Insider Program. Please see https://go.microsoft.com/fwlink/?linkid=850659 for more information.",
            USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND => "A virtual switch with the given name was not found.",
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND => "Cannot restore this virtual machine because a file read from the vSMB saved state data could not be found. Delete the saved state data and then try to start the virtual machine.",
            USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT => "Cannot restore this virtual machine because the vSMB saved state data cannot be read. Delete the saved state data and then try to start the virtual machine.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND => "Partition state blob not found. Make sure the virtual machine is saved for this content to be included in the saved state file(s).",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND => "Guest memory not found. Make sure the virtual machine is saved for this content to be included in the saved state file(s).",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE => "No virtual processor information found in the saved partition blob. Make sure the virtual machine is saved successfully for this content to be included in the partition state.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED => "A virtual processor has been detected to have nested virtualization enabled. Nested Virtualization is not supported yet by VmSavedStateDumpProvider.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND => "The Windows kernel image address could not be found in the virtual machine saved state.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED => "The given virtual address is not mapped to a physical address.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE => "The virtual processor is not in the correct state for the operation.",
            USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED => "The active virtual trust level is not enabled on the specified virtual processor.",
            USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED => "The attempted DM / resize operation exceeds the supported size.",
        }
    }

    pub fn from_name(name: &str) -> USERMODE_VIRTUALIZATION {
        return match name {
            "ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED" => USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED,
            "HCS_E_TERMINATED_DURING_START" => USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START,
            "HCS_E_IMAGE_MISMATCH" => USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH,
            "HCS_E_HYPERV_NOT_INSTALLED" => USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED,
            "HCS_E_INVALID_STATE" => USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE,
            "HCS_E_UNEXPECTED_EXIT" => USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT,
            "HCS_E_TERMINATED" => USERMODE_VIRTUALIZATION::HCS_E_TERMINATED,
            "HCS_E_CONNECT_FAILED" => USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED,
            "HCS_E_CONNECTION_TIMEOUT" => USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT,
            "HCS_E_CONNECTION_CLOSED" => USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED,
            "HCS_E_UNKNOWN_MESSAGE" => USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE,
            "HCS_E_UNSUPPORTED_PROTOCOL_VERSION" => USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION,
            "HCS_E_INVALID_JSON" => USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON,
            "HCS_E_SYSTEM_NOT_FOUND" => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND,
            "HCS_E_SYSTEM_ALREADY_EXISTS" => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS,
            "HCS_E_SYSTEM_ALREADY_STOPPED" => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED,
            "HCS_E_PROTOCOL_ERROR" => USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR,
            "HCS_E_INVALID_LAYER" => USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER,
            "HCS_E_WINDOWS_INSIDER_REQUIRED" => USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED,
            "HCS_E_SERVICE_NOT_AVAILABLE" => USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE,
            "HCS_E_OPERATION_NOT_STARTED" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED,
            "HCS_E_OPERATION_ALREADY_STARTED" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED,
            "HCS_E_OPERATION_PENDING" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING,
            "HCS_E_OPERATION_TIMEOUT" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT,
            "HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET,
            "HCS_E_OPERATION_RESULT_ALLOCATION_FAILED" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED,
            "HCS_E_ACCESS_DENIED" => USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED,
            "HCS_E_GUEST_CRITICAL_ERROR" => USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR,
            "HCS_E_PROCESS_INFO_NOT_AVAILABLE" => USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE,
            "HCS_E_SERVICE_DISCONNECT" => USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT,
            "HCS_E_PROCESS_ALREADY_STOPPED" => USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED,
            "HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION" => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION,
            "HCS_E_OPERATION_ALREADY_CANCELLED" => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED,
            "WHV_E_UNKNOWN_CAPABILITY" => USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY,
            "WHV_E_INSUFFICIENT_BUFFER" => USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER,
            "WHV_E_UNKNOWN_PROPERTY" => USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY,
            "WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG" => USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG,
            "WHV_E_INVALID_PARTITION_CONFIG" => USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG,
            "WHV_E_GPA_RANGE_NOT_FOUND" => USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND,
            "WHV_E_VP_ALREADY_EXISTS" => USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS,
            "WHV_E_VP_DOES_NOT_EXIST" => USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST,
            "WHV_E_INVALID_VP_STATE" => USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE,
            "WHV_E_INVALID_VP_REGISTER_NAME" => USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME,
            "WHV_E_UNSUPPORTED_PROCESSOR_CONFIG" => USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG,
            "ERROR_VID_DUPLICATE_HANDLER" => USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER,
            "ERROR_VID_TOO_MANY_HANDLERS" => USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS,
            "ERROR_VID_QUEUE_FULL" => USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL,
            "ERROR_VID_HANDLER_NOT_PRESENT" => USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT,
            "ERROR_VID_INVALID_OBJECT_NAME" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME,
            "ERROR_VID_PARTITION_NAME_TOO_LONG" => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG,
            "ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG" => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG,
            "ERROR_VID_PARTITION_ALREADY_EXISTS" => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS,
            "ERROR_VID_PARTITION_DOES_NOT_EXIST" => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST,
            "ERROR_VID_PARTITION_NAME_NOT_FOUND" => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND,
            "ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS" => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS,
            "ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT" => USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT,
            "ERROR_VID_MB_STILL_REFERENCED" => USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED,
            "ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED" => USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED,
            "ERROR_VID_INVALID_NUMA_SETTINGS" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS,
            "ERROR_VID_INVALID_NUMA_NODE_INDEX" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX,
            "ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED" => USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED,
            "ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE,
            "ERROR_VID_PAGE_RANGE_OVERFLOW" => USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW,
            "ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE,
            "ERROR_VID_INVALID_GPA_RANGE_HANDLE" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE,
            "ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE" => USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE,
            "ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED" => USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED,
            "ERROR_VID_INVALID_PPM_HANDLE" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE,
            "ERROR_VID_MBPS_ARE_LOCKED" => USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED,
            "ERROR_VID_MESSAGE_QUEUE_CLOSED" => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED,
            "ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED" => USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED,
            "ERROR_VID_STOP_PENDING" => USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING,
            "ERROR_VID_INVALID_PROCESSOR_STATE" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE,
            "ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT" => USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT,
            "ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED" => USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED,
            "ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET" => USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET,
            "ERROR_VID_MMIO_RANGE_DESTROYED" => USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED,
            "ERROR_VID_INVALID_CHILD_GPA_PAGE_SET" => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET,
            "ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED" => USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED,
            "ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL" => USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL,
            "ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE" => USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE,
            "ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT" => USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT,
            "ERROR_VID_SAVED_STATE_CORRUPT" => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT,
            "ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM" => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM,
            "ERROR_VID_SAVED_STATE_INCOMPATIBLE" => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE,
            "ERROR_VID_VTL_ACCESS_DENIED" => USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED,
            "ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE" => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE,
            "ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER" => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER,
            "ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT" => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT,
            "ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED" => USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED,
            "ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW" => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW,
            "ERROR_VID_PROCESS_ALREADY_SET" => USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET,
            "ERROR_VMCOMPUTE_TERMINATED_DURING_START" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START,
            "ERROR_VMCOMPUTE_IMAGE_MISMATCH" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH,
            "ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED,
            "ERROR_VMCOMPUTE_OPERATION_PENDING" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING,
            "ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS,
            "ERROR_VMCOMPUTE_INVALID_STATE" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE,
            "ERROR_VMCOMPUTE_UNEXPECTED_EXIT" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT,
            "ERROR_VMCOMPUTE_TERMINATED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED,
            "ERROR_VMCOMPUTE_CONNECT_FAILED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED,
            "ERROR_VMCOMPUTE_TIMEOUT" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT,
            "ERROR_VMCOMPUTE_CONNECTION_CLOSED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED,
            "ERROR_VMCOMPUTE_UNKNOWN_MESSAGE" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE,
            "ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION,
            "ERROR_VMCOMPUTE_INVALID_JSON" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON,
            "ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND,
            "ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS,
            "ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED,
            "ERROR_VMCOMPUTE_PROTOCOL_ERROR" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR,
            "ERROR_VMCOMPUTE_INVALID_LAYER" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER,
            "ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED" => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED,
            "ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND" => USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND,
            "ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND" => USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND,
            "ERROR_VSMB_SAVED_STATE_CORRUPT" => USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT,
            "VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND,
            "VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND,
            "VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE,
            "VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED,
            "VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND,
            "VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED,
            "VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE,
            "VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED" => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED,
            "ERROR_DM_OPERATION_LIMIT_EXCEEDED" => USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED,
        }
    }
    pub fn from_code(code: u32) -> USERMODE_VIRTUALIZATION {
        return match code {
            0x80370001 => USERMODE_VIRTUALIZATION::ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED,
            0x80370100 => USERMODE_VIRTUALIZATION::HCS_E_TERMINATED_DURING_START,
            0x80370101 => USERMODE_VIRTUALIZATION::HCS_E_IMAGE_MISMATCH,
            0x80370102 => USERMODE_VIRTUALIZATION::HCS_E_HYPERV_NOT_INSTALLED,
            0x80370105 => USERMODE_VIRTUALIZATION::HCS_E_INVALID_STATE,
            0x80370106 => USERMODE_VIRTUALIZATION::HCS_E_UNEXPECTED_EXIT,
            0x80370107 => USERMODE_VIRTUALIZATION::HCS_E_TERMINATED,
            0x80370108 => USERMODE_VIRTUALIZATION::HCS_E_CONNECT_FAILED,
            0x80370109 => USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_TIMEOUT,
            0x8037010A => USERMODE_VIRTUALIZATION::HCS_E_CONNECTION_CLOSED,
            0x8037010B => USERMODE_VIRTUALIZATION::HCS_E_UNKNOWN_MESSAGE,
            0x8037010C => USERMODE_VIRTUALIZATION::HCS_E_UNSUPPORTED_PROTOCOL_VERSION,
            0x8037010D => USERMODE_VIRTUALIZATION::HCS_E_INVALID_JSON,
            0x8037010E => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_FOUND,
            0x8037010F => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_EXISTS,
            0x80370110 => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_ALREADY_STOPPED,
            0x80370111 => USERMODE_VIRTUALIZATION::HCS_E_PROTOCOL_ERROR,
            0x80370112 => USERMODE_VIRTUALIZATION::HCS_E_INVALID_LAYER,
            0x80370113 => USERMODE_VIRTUALIZATION::HCS_E_WINDOWS_INSIDER_REQUIRED,
            0x80370114 => USERMODE_VIRTUALIZATION::HCS_E_SERVICE_NOT_AVAILABLE,
            0x80370115 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_NOT_STARTED,
            0x80370116 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_STARTED,
            0x80370117 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_PENDING,
            0x80370118 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_TIMEOUT,
            0x80370119 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_SYSTEM_CALLBACK_ALREADY_SET,
            0x8037011A => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_RESULT_ALLOCATION_FAILED,
            0x8037011B => USERMODE_VIRTUALIZATION::HCS_E_ACCESS_DENIED,
            0x8037011C => USERMODE_VIRTUALIZATION::HCS_E_GUEST_CRITICAL_ERROR,
            0x8037011D => USERMODE_VIRTUALIZATION::HCS_E_PROCESS_INFO_NOT_AVAILABLE,
            0x8037011E => USERMODE_VIRTUALIZATION::HCS_E_SERVICE_DISCONNECT,
            0x8037011F => USERMODE_VIRTUALIZATION::HCS_E_PROCESS_ALREADY_STOPPED,
            0x80370120 => USERMODE_VIRTUALIZATION::HCS_E_SYSTEM_NOT_CONFIGURED_FOR_OPERATION,
            0x80370121 => USERMODE_VIRTUALIZATION::HCS_E_OPERATION_ALREADY_CANCELLED,
            0x80370300 => USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_CAPABILITY,
            0x80370301 => USERMODE_VIRTUALIZATION::WHV_E_INSUFFICIENT_BUFFER,
            0x80370302 => USERMODE_VIRTUALIZATION::WHV_E_UNKNOWN_PROPERTY,
            0x80370303 => USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_HYPERVISOR_CONFIG,
            0x80370304 => USERMODE_VIRTUALIZATION::WHV_E_INVALID_PARTITION_CONFIG,
            0x80370305 => USERMODE_VIRTUALIZATION::WHV_E_GPA_RANGE_NOT_FOUND,
            0x80370306 => USERMODE_VIRTUALIZATION::WHV_E_VP_ALREADY_EXISTS,
            0x80370307 => USERMODE_VIRTUALIZATION::WHV_E_VP_DOES_NOT_EXIST,
            0x80370308 => USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_STATE,
            0x80370309 => USERMODE_VIRTUALIZATION::WHV_E_INVALID_VP_REGISTER_NAME,
            0x80370310 => USERMODE_VIRTUALIZATION::WHV_E_UNSUPPORTED_PROCESSOR_CONFIG,
            0xC0370001 => USERMODE_VIRTUALIZATION::ERROR_VID_DUPLICATE_HANDLER,
            0xC0370002 => USERMODE_VIRTUALIZATION::ERROR_VID_TOO_MANY_HANDLERS,
            0xC0370003 => USERMODE_VIRTUALIZATION::ERROR_VID_QUEUE_FULL,
            0xC0370004 => USERMODE_VIRTUALIZATION::ERROR_VID_HANDLER_NOT_PRESENT,
            0xC0370005 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_OBJECT_NAME,
            0xC0370006 => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_TOO_LONG,
            0xC0370007 => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG,
            0xC0370008 => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_ALREADY_EXISTS,
            0xC0370009 => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_DOES_NOT_EXIST,
            0xC037000A => USERMODE_VIRTUALIZATION::ERROR_VID_PARTITION_NAME_NOT_FOUND,
            0xC037000B => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS,
            0xC037000C => USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT,
            0xC037000D => USERMODE_VIRTUALIZATION::ERROR_VID_MB_STILL_REFERENCED,
            0xC037000E => USERMODE_VIRTUALIZATION::ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED,
            0xC037000F => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_SETTINGS,
            0xC0370010 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_NUMA_NODE_INDEX,
            0xC0370011 => USERMODE_VIRTUALIZATION::ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED,
            0xC0370012 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE,
            0xC0370013 => USERMODE_VIRTUALIZATION::ERROR_VID_PAGE_RANGE_OVERFLOW,
            0xC0370014 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE,
            0xC0370015 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_GPA_RANGE_HANDLE,
            0xC0370016 => USERMODE_VIRTUALIZATION::ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE,
            0xC0370017 => USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED,
            0xC0370018 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PPM_HANDLE,
            0xC0370019 => USERMODE_VIRTUALIZATION::ERROR_VID_MBPS_ARE_LOCKED,
            0xC037001A => USERMODE_VIRTUALIZATION::ERROR_VID_MESSAGE_QUEUE_CLOSED,
            0xC037001B => USERMODE_VIRTUALIZATION::ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED,
            0xC037001C => USERMODE_VIRTUALIZATION::ERROR_VID_STOP_PENDING,
            0xC037001D => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_PROCESSOR_STATE,
            0xC037001E => USERMODE_VIRTUALIZATION::ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT,
            0xC037001F => USERMODE_VIRTUALIZATION::ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED,
            0xC0370020 => USERMODE_VIRTUALIZATION::ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET,
            0xC0370021 => USERMODE_VIRTUALIZATION::ERROR_VID_MMIO_RANGE_DESTROYED,
            0xC0370022 => USERMODE_VIRTUALIZATION::ERROR_VID_INVALID_CHILD_GPA_PAGE_SET,
            0xC0370023 => USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED,
            0xC0370024 => USERMODE_VIRTUALIZATION::ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL,
            0xC0370025 => USERMODE_VIRTUALIZATION::ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE,
            0xC0370026 => USERMODE_VIRTUALIZATION::ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT,
            0xC0370027 => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_CORRUPT,
            0xC0370028 => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM,
            0xC0370029 => USERMODE_VIRTUALIZATION::ERROR_VID_SAVED_STATE_INCOMPATIBLE,
            0xC037002A => USERMODE_VIRTUALIZATION::ERROR_VID_VTL_ACCESS_DENIED,
            0xC037002B => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_RESERVE,
            0xC037002C => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_PHYSICAL_BUFFER,
            0xC037002D => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_HV_DEPOSIT,
            0xC037002E => USERMODE_VIRTUALIZATION::ERROR_VID_MEMORY_TYPE_NOT_SUPPORTED,
            0xC037002F => USERMODE_VIRTUALIZATION::ERROR_VID_INSUFFICIENT_RESOURCES_WITHDRAW,
            0xC0370030 => USERMODE_VIRTUALIZATION::ERROR_VID_PROCESS_ALREADY_SET,
            0xC0370100 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED_DURING_START,
            0xC0370101 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_IMAGE_MISMATCH,
            0xC0370102 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED,
            0xC0370103 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_OPERATION_PENDING,
            0xC0370104 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS,
            0xC0370105 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_STATE,
            0xC0370106 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNEXPECTED_EXIT,
            0xC0370107 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TERMINATED,
            0xC0370108 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECT_FAILED,
            0xC0370109 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_TIMEOUT,
            0xC037010A => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_CONNECTION_CLOSED,
            0xC037010B => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNKNOWN_MESSAGE,
            0xC037010C => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION,
            0xC037010D => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_JSON,
            0xC037010E => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND,
            0xC037010F => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS,
            0xC0370110 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED,
            0xC0370111 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_PROTOCOL_ERROR,
            0xC0370112 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_INVALID_LAYER,
            0xC0370113 => USERMODE_VIRTUALIZATION::ERROR_VMCOMPUTE_WINDOWS_INSIDER_REQUIRED,
            0xC0370200 => USERMODE_VIRTUALIZATION::ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND,
            0xC0370400 => USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_FILE_NOT_FOUND,
            0xC0370401 => USERMODE_VIRTUALIZATION::ERROR_VSMB_SAVED_STATE_CORRUPT,
            0xC0370500 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_PARTITION_STATE_NOT_FOUND,
            0xC0370501 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_GUEST_MEMORY_NOT_FOUND,
            0xC0370502 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NO_VP_FOUND_IN_PARTITION_STATE,
            0xC0370503 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_NESTED_VIRTUALIZATION_NOT_SUPPORTED,
            0xC0370504 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_WINDOWS_KERNEL_IMAGE_NOT_FOUND,
            0xC0370505 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VA_NOT_MAPPED,
            0xC0370506 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_INVALID_VP_STATE,
            0xC0370509 => USERMODE_VIRTUALIZATION::VM_SAVED_STATE_DUMP_E_VP_VTL_NOT_ENABLED,
            0xC0370600 => USERMODE_VIRTUALIZATION::ERROR_DM_OPERATION_LIMIT_EXCEEDED,
        }
    }
}
