/*
 * Copyright 2023 Stanislav Mikhailov (xavetar)
 *
 * Licensed under the Creative Commons Zero v1.0 Universal (CC0) License.
 * You may obtain a copy of the License at
 *
 *     http://creativecommons.org/publicdomain/zero/1.0/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the CC0 license is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// It is strictly forbidden to use the from_code method, respected Microsoft decided to define
// duplicate codes, but by defining different constant names, therefore, when using these codes,
// it is mandatory to use through from_name, and not from_code. Otherwise, it may cause undefined
// behavior or an unknown exception. Because one code corresponds to several constants.

use super::{RawError};

#[derive(Clone, Debug, Copy, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum USERMODE_VOLMGR {
    ERROR_VOLMGR_INCOMPLETE_REGENERATION,
    ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION,
    ERROR_VOLMGR_DATABASE_FULL,
    ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED,
    ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC,
    ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED,
    ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME,
    ERROR_VOLMGR_DISK_DUPLICATE,
    ERROR_VOLMGR_DISK_DYNAMIC,
    ERROR_VOLMGR_DISK_ID_INVALID,
    ERROR_VOLMGR_DISK_INVALID,
    ERROR_VOLMGR_DISK_LAST_VOTER,
    ERROR_VOLMGR_DISK_LAYOUT_INVALID,
    ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS,
    ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED,
    ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL,
    ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS,
    ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS,
    ERROR_VOLMGR_DISK_MISSING,
    ERROR_VOLMGR_DISK_NOT_EMPTY,
    ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE,
    ERROR_VOLMGR_DISK_REVECTORING_FAILED,
    ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID,
    ERROR_VOLMGR_DISK_SET_NOT_CONTAINED,
    ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS,
    ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES,
    ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED,
    ERROR_VOLMGR_EXTENT_ALREADY_USED,
    ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS,
    ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION,
    ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED,
    ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION,
    ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH,
    ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED,
    ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID,
    ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS,
    ERROR_VOLMGR_MEMBER_IN_SYNC,
    ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE,
    ERROR_VOLMGR_MEMBER_INDEX_INVALID,
    ERROR_VOLMGR_MEMBER_MISSING,
    ERROR_VOLMGR_MEMBER_NOT_DETACHED,
    ERROR_VOLMGR_MEMBER_REGENERATING,
    ERROR_VOLMGR_ALL_DISKS_FAILED,
    ERROR_VOLMGR_NO_REGISTERED_USERS,
    ERROR_VOLMGR_NO_SUCH_USER,
    ERROR_VOLMGR_NOTIFICATION_RESET,
    ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID,
    ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID,
    ERROR_VOLMGR_PACK_DUPLICATE,
    ERROR_VOLMGR_PACK_ID_INVALID,
    ERROR_VOLMGR_PACK_INVALID,
    ERROR_VOLMGR_PACK_NAME_INVALID,
    ERROR_VOLMGR_PACK_OFFLINE,
    ERROR_VOLMGR_PACK_HAS_QUORUM,
    ERROR_VOLMGR_PACK_WITHOUT_QUORUM,
    ERROR_VOLMGR_PARTITION_STYLE_INVALID,
    ERROR_VOLMGR_PARTITION_UPDATE_FAILED,
    ERROR_VOLMGR_PLEX_IN_SYNC,
    ERROR_VOLMGR_PLEX_INDEX_DUPLICATE,
    ERROR_VOLMGR_PLEX_INDEX_INVALID,
    ERROR_VOLMGR_PLEX_LAST_ACTIVE,
    ERROR_VOLMGR_PLEX_MISSING,
    ERROR_VOLMGR_PLEX_REGENERATING,
    ERROR_VOLMGR_PLEX_TYPE_INVALID,
    ERROR_VOLMGR_PLEX_NOT_RAID5,
    ERROR_VOLMGR_PLEX_NOT_SIMPLE,
    ERROR_VOLMGR_STRUCTURE_SIZE_INVALID,
    ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS,
    ERROR_VOLMGR_TRANSACTION_IN_PROGRESS,
    ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE,
    ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK,
    ERROR_VOLMGR_VOLUME_ID_INVALID,
    ERROR_VOLMGR_VOLUME_LENGTH_INVALID,
    ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE,
    ERROR_VOLMGR_VOLUME_NOT_MIRRORED,
    ERROR_VOLMGR_VOLUME_NOT_RETAINED,
    ERROR_VOLMGR_VOLUME_OFFLINE,
    ERROR_VOLMGR_VOLUME_RETAINED,
    ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID,
    ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE,
    ERROR_VOLMGR_BAD_BOOT_DISK,
    ERROR_VOLMGR_PACK_CONFIG_OFFLINE,
    ERROR_VOLMGR_PACK_CONFIG_ONLINE,
    ERROR_VOLMGR_NOT_PRIMARY_PACK,
    ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED,
    ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID,
    ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID,
    ERROR_VOLMGR_VOLUME_MIRRORED,
    ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED,
    ERROR_VOLMGR_NO_VALID_LOG_COPIES,
    ERROR_VOLMGR_PRIMARY_PACK_PRESENT,
    ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID,
    ERROR_VOLMGR_MIRROR_NOT_SUPPORTED,
    ERROR_VOLMGR_RAID5_NOT_SUPPORTED,
}

impl USERMODE_VOLMGR {
    pub fn code(&self) -> u32 {
        return match self {
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION => 0x80380001 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION => 0x80380002 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL => 0xC0380001 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED => 0xC0380002 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC => 0xC0380003 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED => 0xC0380004 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME => 0xC0380005 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE => 0xC0380006 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC => 0xC0380007 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID => 0xC0380008 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID => 0xC0380009 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER => 0xC038000A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID => 0xC038000B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS => 0xC038000C as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED => 0xC038000D as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL => 0xC038000E as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS => 0xC038000F as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS => 0xC0380010 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING => 0xC0380011 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY => 0xC0380012 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE => 0xC0380013 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED => 0xC0380014 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID => 0xC0380015 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED => 0xC0380016 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS => 0xC0380017 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES => 0xC0380018 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED => 0xC0380019 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED => 0xC038001A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS => 0xC038001B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION => 0xC038001C as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED => 0xC038001D as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION => 0xC038001E as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH => 0xC038001F as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED => 0xC0380020 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID => 0xC0380021 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS => 0xC0380022 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC => 0xC0380023 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE => 0xC0380024 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID => 0xC0380025 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING => 0xC0380026 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED => 0xC0380027 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING => 0xC0380028 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED => 0xC0380029 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS => 0xC038002A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER => 0xC038002B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET => 0xC038002C as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID => 0xC038002D as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID => 0xC038002E as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE => 0xC038002F as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID => 0xC0380030 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID => 0xC0380031 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID => 0xC0380032 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE => 0xC0380033 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM => 0xC0380034 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM => 0xC0380035 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID => 0xC0380036 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED => 0xC0380037 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC => 0xC0380038 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE => 0xC0380039 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID => 0xC038003A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE => 0xC038003B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING => 0xC038003C as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING => 0xC038003D as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID => 0xC038003E as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5 => 0xC038003F as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE => 0xC0380040 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID => 0xC0380041 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS => 0xC0380042 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS => 0xC0380043 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE => 0xC0380044 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK => 0xC0380045 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID => 0xC0380046 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID => 0xC0380047 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE => 0xC0380048 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED => 0xC0380049 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED => 0xC038004A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE => 0xC038004B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED => 0xC038004C as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID => 0xC038004D as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE => 0xC038004E as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK => 0xC038004F as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE => 0xC0380050 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE => 0xC0380051 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK => 0xC0380052 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED => 0xC0380053 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID => 0xC0380054 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID => 0xC0380055 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED => 0xC0380056 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED => 0xC0380057 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES => 0xC0380058 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT => 0xC0380059 as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID => 0xC038005A as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED => 0xC038005B as u32,
            USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED => 0xC038005C as u32,
        }
    }

    pub fn error(&self) -> RawError {
        return match self {
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION),
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION),
            USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS),
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES),
            USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION),
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH),
            USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED),
            USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED),
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING),
            USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED),
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS),
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER),
            USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM),
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5 => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE),
            USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS),
            USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS),
            USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE),
            USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE),
            USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK),
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED),
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED),
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES),
            USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT),
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID),
            USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED),
            USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED => RawError::Kind(USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED),
        }
    }

    pub fn description(&self) -> &'static str {
        return match self {
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION => "The regeneration operation was not able to copy all data from the active plexes due to bad sectors.",
            USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION => "One or more disks were not fully migrated to the target pack. They may or may not require reimport after fixing the hardware problems.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL => "The configuration database is full.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED => "The configuration data on the disk is corrupted.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC => "The configuration on the disk is not insync with the in-memory configuration.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED => "A majority of disks failed to be updated with the new configuration.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME => "The disk contains non-simple volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE => "The same disk was specified more than once in the migration list.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC => "The disk is already dynamic.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID => "The specified disk id is invalid. There are no disks with the specified disk id.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID => "The specified disk is an invalid disk. Operation cannot complete on an invalid disk.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER => "The specified disk(s) cannot be removed since it is the last remaining voter.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID => "The specified disk has an invalid disk layout.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS => "The disk layout contains non-basic partitions which appear after basic partitions. This is an invalid disk layout.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED => "The disk layout contains partitions which are not cylinder aligned.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL => "The disk layout contains partitions which are smaller than the minimum size.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS => "The disk layout contains primary partitions in between logical drives. This is an invalid disk layout.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS => "The disk layout contains more than the maximum number of supported partitions.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING => "The specified disk is missing. The operation cannot complete on a missing disk.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY => "The specified disk is not empty.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE => "There is not enough usable space for this operation.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED => "The force revectoring of bad sectors failed.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID => "The specified disk has an invalid sector size.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED => "The specified disk set contains volumes which exist on disks outside of the set.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS => "A disk in the volume layout provides extents to more than one member of a plex.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES => "A disk in the volume layout provides extents to more than one plex.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED => "Dynamic disks are not supported on this system.",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED => "The specified extent is already used by other volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS => "The specified volume is retained and can only be extended into a contiguous extent. The specified extent to grow the volume is not contiguous with the specified volume.",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION => "The specified volume extent is not within the public region of the disk.",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED => "The specified volume extent is not sector aligned.",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION => "The specified partition overlaps an EBR (the first track of an extended partition on an MBR disk).",
            USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH => "The specified extent lengths cannot be used to construct a volume with specified length.",
            USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED => "The system does not support fault tolerant volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID => "The specified interleave length is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS => "There is already a maximum number of registered users.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC => "The specified member is already in-sync with the other active members. It does not need to be regenerated.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE => "The same member index was specified more than once.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID => "The specified member index is greater or equal than the number of members in the volume plex.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING => "The specified member is missing. It cannot be regenerated.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED => "The specified member is not detached. Cannot replace a member which is not detached.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING => "The specified member is already regenerating.",
            USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED => "All disks belonging to the pack failed.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS => "There are currently no registered users for notifications. The task number is irrelevant unless there are registered users.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER => "The specified notification user does not exist. Failed to unregister user for notifications.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET => "The notifications have been reset. Notifications for the current user are invalid. Unregister and re-register for notifications.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID => "The specified number of members is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID => "The specified number of plexes is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE => "The specified source and target packs are identical.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID => "The specified pack id is invalid. There are no packs with the specified pack id.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID => "The specified pack is the invalid pack. The operation cannot complete with the invalid pack.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID => "The specified pack name is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE => "The specified pack is offline.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM => "The specified pack already has a quorum of healthy disks.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM => "The pack does not have a quorum of healthy disks.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID => "The specified disk has an unsupported partition style. Only MBR and GPT partition styles are supported.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED => "Failed to update the disk's partition layout.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC => "The specified plex is already in-sync with the other active plexes. It does not need to be regenerated.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE => "The same plex index was specified more than once.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID => "The specified plex index is greater or equal than the number of plexes in the volume.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE => "The specified plex is the last active plex in the volume. The plex cannot be removed or else the volume will go offline.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING => "The specified plex is missing.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING => "The specified plex is currently regenerating.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID => "The specified plex type is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5 => "The operation is only supported on RAID-5 plexes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE => "The operation is only supported on simple plexes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID => "The Size fields in the VM_VOLUME_LAYOUT input structure are incorrectly set.",
            USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS => "There is already a pending request for notifications. Wait for the existing request to return before requesting for more notifications.",
            USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS => "There is currently a transaction in process.",
            USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE => "An unexpected layout change occurred outside of the volume manager.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK => "The specified volume contains a missing disk.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID => "The specified volume id is invalid. There are no volumes with the specified volume id.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID => "The specified volume length is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE => "The specified size for the volume is not a multiple of the sector size.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED => "The operation is only supported on mirrored volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED => "The specified volume does not have a retain partition.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE => "The specified volume is offline.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED => "The specified volume already has a retain partition.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID => "The specified number of extents is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE => "All disks participating to the volume must have the same sector size.",
            USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK => "The boot disk experienced failures.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE => "The configuration of the pack is offline.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE => "The configuration of the pack is online.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK => "The specified pack is not the primary pack.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED => "All disks failed to be updated with the new content of the log.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID => "The specified number of disks in a plex is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID => "The specified number of disks in a plex member is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED => "The operation is not supported on mirrored volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED => "The operation is only supported on simple and spanned plexes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES => "The pack has no valid log copies.",
            USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT => "A primary pack is already present.",
            USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID => "The specified number of disks is invalid.",
            USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED => "The system does not support mirrored volumes.",
            USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED => "The system does not support RAID-5 volumes.",
        }
    }

    pub fn from_name(name: &str) -> USERMODE_VOLMGR {
        return match name {
            "ERROR_VOLMGR_INCOMPLETE_REGENERATION" => USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION,
            "ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION" => USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION,
            "ERROR_VOLMGR_DATABASE_FULL" => USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL,
            "ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED,
            "ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC,
            "ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED,
            "ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME,
            "ERROR_VOLMGR_DISK_DUPLICATE" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE,
            "ERROR_VOLMGR_DISK_DYNAMIC" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC,
            "ERROR_VOLMGR_DISK_ID_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID,
            "ERROR_VOLMGR_DISK_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID,
            "ERROR_VOLMGR_DISK_LAST_VOTER" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER,
            "ERROR_VOLMGR_DISK_LAYOUT_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID,
            "ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS,
            "ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED,
            "ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL,
            "ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS,
            "ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS,
            "ERROR_VOLMGR_DISK_MISSING" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING,
            "ERROR_VOLMGR_DISK_NOT_EMPTY" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY,
            "ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE,
            "ERROR_VOLMGR_DISK_REVECTORING_FAILED" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED,
            "ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID,
            "ERROR_VOLMGR_DISK_SET_NOT_CONTAINED" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED,
            "ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS,
            "ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES" => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES,
            "ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED" => USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED,
            "ERROR_VOLMGR_EXTENT_ALREADY_USED" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED,
            "ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS,
            "ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION,
            "ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED,
            "ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION,
            "ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH" => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH,
            "ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED" => USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED,
            "ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID,
            "ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS" => USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS,
            "ERROR_VOLMGR_MEMBER_IN_SYNC" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC,
            "ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE,
            "ERROR_VOLMGR_MEMBER_INDEX_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID,
            "ERROR_VOLMGR_MEMBER_MISSING" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING,
            "ERROR_VOLMGR_MEMBER_NOT_DETACHED" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED,
            "ERROR_VOLMGR_MEMBER_REGENERATING" => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING,
            "ERROR_VOLMGR_ALL_DISKS_FAILED" => USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED,
            "ERROR_VOLMGR_NO_REGISTERED_USERS" => USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS,
            "ERROR_VOLMGR_NO_SUCH_USER" => USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER,
            "ERROR_VOLMGR_NOTIFICATION_RESET" => USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET,
            "ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID,
            "ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID,
            "ERROR_VOLMGR_PACK_DUPLICATE" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE,
            "ERROR_VOLMGR_PACK_ID_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID,
            "ERROR_VOLMGR_PACK_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID,
            "ERROR_VOLMGR_PACK_NAME_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID,
            "ERROR_VOLMGR_PACK_OFFLINE" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE,
            "ERROR_VOLMGR_PACK_HAS_QUORUM" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM,
            "ERROR_VOLMGR_PACK_WITHOUT_QUORUM" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM,
            "ERROR_VOLMGR_PARTITION_STYLE_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID,
            "ERROR_VOLMGR_PARTITION_UPDATE_FAILED" => USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED,
            "ERROR_VOLMGR_PLEX_IN_SYNC" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC,
            "ERROR_VOLMGR_PLEX_INDEX_DUPLICATE" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE,
            "ERROR_VOLMGR_PLEX_INDEX_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID,
            "ERROR_VOLMGR_PLEX_LAST_ACTIVE" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE,
            "ERROR_VOLMGR_PLEX_MISSING" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING,
            "ERROR_VOLMGR_PLEX_REGENERATING" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING,
            "ERROR_VOLMGR_PLEX_TYPE_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID,
            "ERROR_VOLMGR_PLEX_NOT_RAID5" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5,
            "ERROR_VOLMGR_PLEX_NOT_SIMPLE" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE,
            "ERROR_VOLMGR_STRUCTURE_SIZE_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID,
            "ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS" => USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS,
            "ERROR_VOLMGR_TRANSACTION_IN_PROGRESS" => USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS,
            "ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE" => USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE,
            "ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK,
            "ERROR_VOLMGR_VOLUME_ID_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID,
            "ERROR_VOLMGR_VOLUME_LENGTH_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID,
            "ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE,
            "ERROR_VOLMGR_VOLUME_NOT_MIRRORED" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED,
            "ERROR_VOLMGR_VOLUME_NOT_RETAINED" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED,
            "ERROR_VOLMGR_VOLUME_OFFLINE" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE,
            "ERROR_VOLMGR_VOLUME_RETAINED" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED,
            "ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID,
            "ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE" => USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE,
            "ERROR_VOLMGR_BAD_BOOT_DISK" => USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK,
            "ERROR_VOLMGR_PACK_CONFIG_OFFLINE" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE,
            "ERROR_VOLMGR_PACK_CONFIG_ONLINE" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE,
            "ERROR_VOLMGR_NOT_PRIMARY_PACK" => USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK,
            "ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED" => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED,
            "ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID,
            "ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID,
            "ERROR_VOLMGR_VOLUME_MIRRORED" => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED,
            "ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED" => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED,
            "ERROR_VOLMGR_NO_VALID_LOG_COPIES" => USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES,
            "ERROR_VOLMGR_PRIMARY_PACK_PRESENT" => USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT,
            "ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID" => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID,
            "ERROR_VOLMGR_MIRROR_NOT_SUPPORTED" => USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED,
            "ERROR_VOLMGR_RAID5_NOT_SUPPORTED" => USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED,
        }
    }
    pub fn from_code(code: u32) -> USERMODE_VOLMGR {
        return match code {
            0x80380001 => USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_REGENERATION,
            0x80380002 => USERMODE_VOLMGR::ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION,
            0xC0380001 => USERMODE_VOLMGR::ERROR_VOLMGR_DATABASE_FULL,
            0xC0380002 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED,
            0xC0380003 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC,
            0xC0380004 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED,
            0xC0380005 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME,
            0xC0380006 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DUPLICATE,
            0xC0380007 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_DYNAMIC,
            0xC0380008 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_ID_INVALID,
            0xC0380009 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_INVALID,
            0xC038000A => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAST_VOTER,
            0xC038000B => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_INVALID,
            0xC038000C => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS,
            0xC038000D => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED,
            0xC038000E => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL,
            0xC038000F => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS,
            0xC0380010 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS,
            0xC0380011 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_MISSING,
            0xC0380012 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_EMPTY,
            0xC0380013 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE,
            0xC0380014 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_REVECTORING_FAILED,
            0xC0380015 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID,
            0xC0380016 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_SET_NOT_CONTAINED,
            0xC0380017 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS,
            0xC0380018 => USERMODE_VOLMGR::ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES,
            0xC0380019 => USERMODE_VOLMGR::ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED,
            0xC038001A => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_ALREADY_USED,
            0xC038001B => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS,
            0xC038001C => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION,
            0xC038001D => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED,
            0xC038001E => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION,
            0xC038001F => USERMODE_VOLMGR::ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH,
            0xC0380020 => USERMODE_VOLMGR::ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED,
            0xC0380021 => USERMODE_VOLMGR::ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID,
            0xC0380022 => USERMODE_VOLMGR::ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS,
            0xC0380023 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_IN_SYNC,
            0xC0380024 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE,
            0xC0380025 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_INDEX_INVALID,
            0xC0380026 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_MISSING,
            0xC0380027 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_NOT_DETACHED,
            0xC0380028 => USERMODE_VOLMGR::ERROR_VOLMGR_MEMBER_REGENERATING,
            0xC0380029 => USERMODE_VOLMGR::ERROR_VOLMGR_ALL_DISKS_FAILED,
            0xC038002A => USERMODE_VOLMGR::ERROR_VOLMGR_NO_REGISTERED_USERS,
            0xC038002B => USERMODE_VOLMGR::ERROR_VOLMGR_NO_SUCH_USER,
            0xC038002C => USERMODE_VOLMGR::ERROR_VOLMGR_NOTIFICATION_RESET,
            0xC038002D => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID,
            0xC038002E => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID,
            0xC038002F => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_DUPLICATE,
            0xC0380030 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_ID_INVALID,
            0xC0380031 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_INVALID,
            0xC0380032 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_NAME_INVALID,
            0xC0380033 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_OFFLINE,
            0xC0380034 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_HAS_QUORUM,
            0xC0380035 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_WITHOUT_QUORUM,
            0xC0380036 => USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_STYLE_INVALID,
            0xC0380037 => USERMODE_VOLMGR::ERROR_VOLMGR_PARTITION_UPDATE_FAILED,
            0xC0380038 => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_IN_SYNC,
            0xC0380039 => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_DUPLICATE,
            0xC038003A => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_INDEX_INVALID,
            0xC038003B => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_LAST_ACTIVE,
            0xC038003C => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_MISSING,
            0xC038003D => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_REGENERATING,
            0xC038003E => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_TYPE_INVALID,
            0xC038003F => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_RAID5,
            0xC0380040 => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE,
            0xC0380041 => USERMODE_VOLMGR::ERROR_VOLMGR_STRUCTURE_SIZE_INVALID,
            0xC0380042 => USERMODE_VOLMGR::ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS,
            0xC0380043 => USERMODE_VOLMGR::ERROR_VOLMGR_TRANSACTION_IN_PROGRESS,
            0xC0380044 => USERMODE_VOLMGR::ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE,
            0xC0380045 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK,
            0xC0380046 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_ID_INVALID,
            0xC0380047 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_INVALID,
            0xC0380048 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE,
            0xC0380049 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_MIRRORED,
            0xC038004A => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_NOT_RETAINED,
            0xC038004B => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_OFFLINE,
            0xC038004C => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_RETAINED,
            0xC038004D => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID,
            0xC038004E => USERMODE_VOLMGR::ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE,
            0xC038004F => USERMODE_VOLMGR::ERROR_VOLMGR_BAD_BOOT_DISK,
            0xC0380050 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_OFFLINE,
            0xC0380051 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_CONFIG_ONLINE,
            0xC0380052 => USERMODE_VOLMGR::ERROR_VOLMGR_NOT_PRIMARY_PACK,
            0xC0380053 => USERMODE_VOLMGR::ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED,
            0xC0380054 => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID,
            0xC0380055 => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID,
            0xC0380056 => USERMODE_VOLMGR::ERROR_VOLMGR_VOLUME_MIRRORED,
            0xC0380057 => USERMODE_VOLMGR::ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED,
            0xC0380058 => USERMODE_VOLMGR::ERROR_VOLMGR_NO_VALID_LOG_COPIES,
            0xC0380059 => USERMODE_VOLMGR::ERROR_VOLMGR_PRIMARY_PACK_PRESENT,
            0xC038005A => USERMODE_VOLMGR::ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID,
            0xC038005B => USERMODE_VOLMGR::ERROR_VOLMGR_MIRROR_NOT_SUPPORTED,
            0xC038005C => USERMODE_VOLMGR::ERROR_VOLMGR_RAID5_NOT_SUPPORTED,
        }
    }
}
